//+------------------------------------------------------------------+
//|                                            BackToTheFuturev2.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                  August 24, 2006 |
//+------------------------------------------------------------------+
#define MAGIC1  11111111
#include <stdlib.mqh>
#define     NL    "\n"

extern int     RiskPercent    = 20;
extern double  PercentEQaboveBalance   = 1.4;
//extern int     TimeFrame      = 30;
extern double  MAperiod       = 100;
extern double  Lotsper10k     = 8;
extern int     TrailingStop   = 45;
extern int     BEpips         = 35;
extern int     High1          = 80;
extern int     Low1           = 60;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           //if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  } 
  
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           //if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders;
   double  TotalProfit, BuyProfit, SellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit();
         if (OrderType() == OP_SELL) SellProfit +=  OrderProfit();
        }
     }
   TotalProfit = BuyProfit + SellProfit;
    
  //---- close buy conditions 
    if(BuyProfit/AccountBalance() >= PercentEQaboveBalance/100) CloseAllThisSymbolBuy(); 
    if(SellProfit/AccountBalance() >= PercentEQaboveBalance/100) CloseAllThisSymbolSell();
    
    return;
  }
  
//+------------------------------------------------------------------+
//| Break even code                                                  |
//+------------------------------------------------------------------+ 
 void DoBE(int byPips)
  {
    for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()==Symbol() && (OrderMagicNumber() == MAGIC1))  
        {
            if (OrderType() == OP_BUY) if (Bid - OrderOpenPrice() > byPips * Point) if (OrderStopLoss() < OrderOpenPrice()) {
              OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() +  Point, OrderTakeProfit(), Red);
            }
            if (OrderType() == OP_SELL) if (OrderOpenPrice() - Ask > byPips * Point) if (OrderStopLoss() > OrderOpenPrice()) { 
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() -  Point, OrderTakeProfit(), Red);
            }
        }
    }
  }

//+------------------------------------------------------------------+
//| Trailing stop code                                               |
//+------------------------------------------------------------------+ 
  void DoTrail()
  {
    for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == MAGIC1))  
        {
          
          if (OrderType() == OP_BUY) {
             if(Bid-OrderOpenPrice()>Point*TrailingStop)
             {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
             }
          }

          if (OrderType() == OP_SELL) 
          {
             if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
             {
                if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                {
                   OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                   return(0);
                }
             }
          }
       }
    }
 }
    
//+------------------------------------------------------------------+
//| Check for Buy order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double MA = iMA(NULL,0, MAperiod, 0, MODE_LWMA, MODE_CLOSE, 0);
   double Lots = ((Lotsper10k/10000)*AccountBalance());
   if(Lots >= 50) Lots = 50;
   
   if(Bid < MA-Low1*Point) OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"",MAGIC1,0,Green);
  }
    
//+------------------------------------------------------------------+
//| Check for Sell order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSell()
  {
   double MA = iMA(NULL,0, MAperiod, 0, MODE_LWMA, MODE_CLOSE, 0);
   double Lots = ((Lotsper10k/10000)*AccountBalance());
   if(Lots >= 50) Lots = 50;

   if(Ask > MA+High1*Point) OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"",MAGIC1,0,Maroon);
  } 
        
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
  
   double  i, OpenBuyLots1, BuyOrders1, OpenSellLots1, SellOrders1, OpenOrders1;
   double  CurrencyProfit1, BuyProfit1, SellProfit1, OpenLots1, TotalLotsOpen;
   double  CurrencyProfit;
   double  PendingBuyStop1, PendingSellStop1, PendingBuyStop2, PendingSellStop2;
   double  PendingBuyStop3, PendingSellStop3, buy1, sell1, buy2, sell2, buy3, sell3;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   bool    needbuy1     = false;
   bool    needsell1    = false;
   int     barminutes   = Period();
        
      for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC1)
        {
         if (OrderType() == OP_BUY)
          {
          buy1 ++;
          datetime  buytradetime1 = OrderOpenTime();
          }
         if (OrderType() == OP_SELL)
          {
          sell1 ++;
          datetime  selltradetime1 = OrderOpenTime();
          }
        }
      }
   
   CheckForClose();
   
   if(BEpips>0) DoBE(BEpips);
   if(TrailingStop>0) DoTrail();

  if(buytradetime1  < Time[1]+ (barminutes*60) || buy1 == 0) needbuy1  = true;
  if(selltradetime1 < Time[1]+ (barminutes*60) || sell1 == 0) needsell1 = true;
   
Comment( " TotalLotsOpen ", TotalLotsOpen,NL,
         " CurrencyProfit ", CurrencyProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));

   if((AccountMargin()/AccountBalance())>RiskPercent/100) return;
        
   if(Volume[0] > 2) return;
   
   CheckForBuy();
   CheckForSell();
                                         
   return;      
  }
//+------------------------------------------------------------------+