//+------------------------------------------------------------------+
//|                                                       BigBar.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                  August 16, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060816
#include <stdlib.mqh>
#define     NL    "\n"

extern int     BarPips   = 35;
extern int     BarTP     = 25;
extern int     BarSL     = 25;
extern double  lots      = 1;
extern int     orders    = 5;
extern bool    wantBuys  = true;
extern bool    wantSells = true;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for Buy conditions                                         |
//+------------------------------------------------------------------+
void CheckForBuys()
  {
   if(wantBuys)
    {
     if(Bid >= Open[0]+BarPips*Point) OrderSend(Symbol(),OP_BUY,lots,Ask,3,BarSL*Point,Ask+BarTP*Point,"",MAGICMA,0,LimeGreen);
    }
  }

//+------------------------------------------------------------------+
//| Check for Sell conditions                                        |
//+------------------------------------------------------------------+
void CheckForSells()
  {
    if(wantSells)
     {
      if(Open[0]-Ask >= BarPips*Point) OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,Bid-BarTP*Point,"",MAGICMA,0,Magenta);
     }
  } 
  
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
      
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, OpenOrders;
   double  CurrencyProfit, BuyProfit, SellProfit, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
          }
        }
     }
   OpenOrders = BuyOrders + SellOrders;
   OpenLots = OpenBuyLots + OpenSellLots;
   CurrencyProfit = BuyProfit + SellProfit;
   if(OpenOrders > orders) return;
   
   CheckForSells();
   
   CheckForBuys();
                                       
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " CurrencyProfit ", CurrencyProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+