//+------------------------------------------------------------------+
//|                                                     BigBarv4.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                  August 16, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060816
#include <stdlib.mqh>
#define     NL    "\n"

extern bool    wantBuys  = true;
extern int     BuyBarPips   = 32;
extern int     BuyBarTP     = 20;
extern int     BuyBarSL     = 25;
extern double  Buylots      = 1;
extern int     Buyorders    = 3;

extern bool    wantSells = true;
extern int     SellBarPips   = 70;
extern int     SellBarTP     = 20;
extern int     SellBarSL     = 25;
extern double  Selllots      = 1;
extern int     Sellorders    = 3;

extern int     TrendTF       = 60;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for Open conditions                                         |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int LongStochK         = 60;     // stochastic setting on "longterm" time frame
   int LongStochD         = 5;     // stochastic setting on "longterm" time frame
   int LongStochSlowing   = 8;     // stochastic setting on "longterm" time frame
   double longstoch1 = iStochastic(NULL,TrendTF,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   double longstoch2 = iStochastic(NULL,TrendTF,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);
   
   if(longstoch1<longstoch2) wantBuys  = false;
   if(longstoch1>longstoch2) wantSells = false;
 
   if(wantBuys)
    {
     if(Bid >= Open[0]+BuyBarPips*Point) OrderSend(Symbol(),OP_BUY,Buylots,Ask,3,Bid-BuyBarSL*Point,Ask+BuyBarTP*Point,"",MAGICMA,0,LimeGreen);
    }
   if(wantSells)
    {
     if(Open[0]-Ask >= SellBarPips*Point) OrderSend(Symbol(),OP_SELL,Selllots,Bid,3,Ask+BuyBarSL*Point,Bid-SellBarTP*Point,"",MAGICMA,0,Magenta);
    }
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
      
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, OpenOrders;
   double  CurrencyProfit, BuyProfit, SellProfit, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
          }
        }
     }
   OpenOrders = BuyOrders + SellOrders;
   OpenLots = OpenBuyLots + OpenSellLots;
   CurrencyProfit = BuyProfit + SellProfit;
   if(BuyOrders > Buyorders) return;
   if(SellOrders > Sellorders) return;
   
   CheckForOpen();
                                       
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " CurrencyProfit ", CurrencyProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+