  //+------------------------------------------------------------------+
//|                                                   DropKickv5.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                 October 19, 2006 |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#define MAGICMA  20060719
#define     NL    "\n" 

extern int TP                 = 2000;
extern int RSIperiod          = 4;
extern int RSIlowerLevel      = 20;
extern int RSIupperLevel      = 80;
extern int StochK             = 4;
extern int StochD             = 3;
extern int StochSlowing       = 2;
extern int StochlowerLevel    = 20;
extern int StochupperLevel    = 80;
extern int vol                = 3;
extern double  ratio          = 0.001;
extern double  ratioall       = 999;
extern int Lotdivider         = 170000; //Optimize for each currency
extern bool AccountIsMini     = true;  // Change to true if trading mini account
extern bool MoneyManagement   = true;  // Change to false to shutdown money management controls.
                                       // Lots = 1 will be in effect and only 1 lot will be open regardless of equity.
extern double Riskpercent     = 0.5;    // Change to whatever percent of equity you wish to risk.
extern double Margincutoff    = 800;   // Expert will stop trading if equity level decreases to that level.
extern int MaxMarginBuy          = 1000;
extern int MaxMarginSell          = 1000;
extern double Lots            = 0.1; 
extern bool OneEntryPerBar       = true;

datetime
         CheckTime,
         CheckEntryTime,
         CrossTime;
         
static int 
         TimeFrame            = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
 
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
}
  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double rsi, stoch, lots, AE, lotMM;
   int    sendbuy, sendsell;
 
lots = NormalizeDouble(AE/Lotdivider, 2); 
AE   = AccountEquity();

//---- select lot size
   double lot=NormalizeDouble(MathFloor(AccountBalance()*Riskpercent/10000)/10,2);
// lot at this point is number of standard lots
// Check if mini or standard Account
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
// Use at least 1 mini lot
   if(lot<0.01) lot=0.01;
  }else
  {
    if (lot < 0.1) lot = 0.1;
    if(AccountMargin() > MaxMarginBuy) return;
    if(AccountMargin() > MaxMarginSell) return;
  }
  
   if(MoneyManagement)lotMM = lot;
   else {
     lotMM = lots;
     if(AccountIsMini)
     {
       if (lotMM > 1.0) lotMM = lotMM / 10;
       if (lotMM < 0.1) lotMM = 0.1;
     }
   }  
    
//---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
//---- RSI indicator
   rsi=iRSI(NULL,15,RSIperiod,PRICE_CLOSE,0); 
//---- Stochastic indicator
   stoch=iStochastic(NULL,15,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_MAIN,0);

//---- sell conditions DOWN
   if(rsi>RSIupperLevel && stoch>StochupperLevel)  
     {
      sendsell=OrderSend(Symbol(),OP_SELL,lotMM,Bid,3,0,Bid-Point*TP,"",MAGICMA,0,Red);
      return;
     }
//---- buy conditions UP
   if(rsi<RSIlowerLevel && stoch<StochlowerLevel)  
     {
      sendbuy=OrderSend(Symbol(),OP_BUY,lotMM,Ask,3,0,Ask+Point*TP,"",MAGICMA,0,Blue);
      return;
     }
//----
  }
  
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)  // only look if mygrid and symbol...
      {
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbol()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, BuySwap, SellSwap;
   double  TotalProfit, BuyProfit, SellProfit, TotalBuyProfit, TotalSellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)
        {
         if (OrderType() == OP_BUY)
           {
            BuyProfit  +=  OrderProfit();
            BuySwap += OrderSwap();
           }
         if (OrderType() == OP_SELL)
           {
            SellProfit +=  OrderProfit();
            SellSwap += OrderSwap();
           }
        }
     }
   TotalBuyProfit = BuyProfit + BuySwap;
   TotalSellProfit = SellProfit + SellSwap;
   TotalProfit = TotalBuyProfit + TotalSellProfit;

  //---- close buy conditions 
    if(TotalBuyProfit/AccountBalance() >= ratio) CloseAllThisSymbolBuy(); 
    if(TotalSellProfit/AccountBalance() >= ratio) CloseAllThisSymbolSell();
    if(TotalProfit/AccountBalance() >= ratioall) CloseAllThisSymbol();
    
    return;
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
  {
  if(AccountFreeMargin() < Margincutoff) return(0);
   
   CheckForClose();
   
   double  ProfitTarget, i;
   double  OpenBuyLots, OpenSellLots, BuyOrders, SellOrders,  leveler, MaxLotsAllowed, TotalLotsOpen;
   double  TotalProfit, BuyProfit, SellProfit, Swap;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);       

//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
   
   if(OneEntryPerBar)
      {
         if(CheckEntryTime==iTime(NULL,TimeFrame,0)) return(0); else CheckEntryTime = iTime(NULL,TimeFrame,0);
      } 
//+------------------------------------------------------------------+
//|  Determine Open Orders/Lots and Pending Orders this Symbol       |
//+------------------------------------------------------------------+
           
    for(i = 0; i < OrdersTotal(); i++)
      {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit()+ OrderSwap() + OrderCommission();
           }
         if (OrderType() == OP_SELL)
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit() + OrderSwap() + OrderCommission();
           {
          }
        }
      }
  
    TotalProfit = BuyProfit + SellProfit;
    
//---- calculate open orders by current symbol
       CheckForOpen();
   if (AccountLeverage() == 200) leveler = 4;    // for mini accounts
   if (AccountLeverage() == 100) leveler = 0.1;  // for standard accounts
   //MaxLotsAllowed = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
   
   if(TotalLotsOpen > MaxLotsAllowed) return;
   if(OpenBuyLots >= MaxLotsAllowed/2) return;
   if(OpenSellLots >= MaxLotsAllowed/2) return;
   if(AccountEquity() <= AccountBalance()/2) return;
   if(OpenBuyLots > MaxMarginBuy) return;
   if(OpenSellLots > MaxMarginSell) return;
   if(AccountMargin() > MaxMarginBuy) return;
   if(AccountMargin() > MaxMarginSell) return;
            
                                  
//----

Comment(" BuyOrders ", BuyOrders,NL,
        " SellOrders ", SellOrders,NL,
        " TotalProfit ", TotalProfit,NL,
        " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+