//+---------------------------------------------------------+
//|                        DK7.mq4 
//|                Copyright  2006, kmrunner 
//|                     October 22, 2006 
//+---------------------------------------------------------+
#include <stdlib.mqh>
#define MAGICMA  20061022
#define     NL    "\n" 

extern double Lots              = 0.2; 
extern bool   LotIncrease       = true;
extern double ratio             = 0.001;
extern double ratioall          = 999;
extern int    Stochtimeframe    = 1440;
extern int    StochK            = 20;
extern int    StochD            = 5;
extern int    StochSlowing      = 2;
extern int    StochlowerLevel   = 10;
extern int    StochupperLevel   = 90;
extern bool   AccountIsMini     = true;  // Change to true if trading mini account
extern bool   OneEntryPerBar    = true;

datetime
         CheckTime,
         CheckEntryTime,
         CrossTime;
         
static int TimeFrame            = 0;
double StartingBalance          = 0;        // lot size control if LotIncrease == true

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if(LotIncrease)
       {
        StartingBalance=AccountBalance()/Lots;
       }
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
 
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
}
  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
  
//---- Stochastic indicator
  double stoch1=iStochastic(NULL,Stochtimeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_MAIN,0);
  double stoch2=iStochastic(NULL,Stochtimeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_MAIN,1);
   
   // Lot increasement based on AccountBalance when expert is started
   // this will trade 1.0, then 1.1, then 1.2 etc as account balance grows
   // or 0.9 then 0.8 then 0.7 as account balance shrinks 
   if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(AccountIsMini && Lots > 50)   Lots = 50.0;
      if(!AccountIsMini && Lots > 100) Lots = 100;
     } 
   
    if(OneEntryPerBar)
      {
         if(CheckEntryTime==iTime(NULL,TimeFrame,0)) return(0); else CheckEntryTime = iTime(NULL,TimeFrame,0);
      }     
      
//---- sell conditions DOWN
   if(stoch1 > StochlowerLevel && stoch2>stoch1)  
     {
      OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"",MAGICMA,0,Red);
      
     }
//---- buy conditions UP
   if(stoch1 < StochupperLevel && stoch1>stoch2)  
     {
      OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"",MAGICMA,0,Blue);
      
     }
//----
 return;
  }
 
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)  // only look if mygrid and symbol...
      {
        //Close opened long positions
        if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)  // only look if mygrid and symbol...
      {
        //Close opened short positions
        if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
  
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbol()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, BuySwap, SellSwap;
   double  TotalProfit, BuyProfit, SellProfit, TotalBuyProfit, TotalSellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGICMA)
        {
         if (OrderType() == OP_BUY)
           {
            BuyProfit  +=  OrderProfit();
            BuySwap += OrderSwap();
           }
         if (OrderType() == OP_SELL)
           {
            SellProfit +=  OrderProfit();
            SellSwap += OrderSwap();
           }
        }
     }
   TotalBuyProfit = BuyProfit + BuySwap;
   TotalSellProfit = SellProfit + SellSwap;
   TotalProfit = TotalBuyProfit + TotalSellProfit;

  //---- close buy conditions 
    if(TotalBuyProfit/AccountBalance() >= ratio)  CloseAllThisSymbolBuy(); 
    if(TotalSellProfit/AccountBalance() >= ratio) CloseAllThisSymbolSell();
    if(TotalProfit/AccountBalance() >= ratio)  CloseAllThisSymbol();
    
    return;
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
  {
   
   CheckForClose();
   
   CheckForOpen();
                                
Comment(" Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));

return;
  }
//+------------------------------------------------------------------+