//+------------------------------------------------------------------+
//|                                                   DropKickv4.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                    July 19, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060719

extern int TP                 = 500;
extern int RSIperiod          = 3;
extern int RSILevel           = 30;
extern int StochK             = 4;
extern int StochD             = 3;
extern int StochSlowing       = 2;
extern int StochLevel         = 30;
extern int vol                = 4;
extern int Lotdivider         = 900000;   //Can go as low as 12000 but 20k will be safer. 
extern int BasketProfit=300;      // if equity reaches this level, close trades
extern int BasketLoss=99999;        // if equity reaches this negative level, close trades

// Min/Max tracking
double maxOrders;
double maxEquity;
double minEquity;

// stoploss and takeprofit and close control
double SL=0;
double CurrentProfit=0;
double CurrentBasket=0;

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double rsi, stoch, lots, AB;
   int    sendbuy;
   
//----
   //Basket profit or loss
   CurrentBasket=AccountEquity()-AccountBalance();
   
   if(CurrentBasket>maxEquity) maxEquity=CurrentBasket;
   if(CurrentBasket<minEquity) minEquity=CurrentBasket;
   
   // actual basket closure
   if( CurrentBasket>=BasketProfit || CurrentBasket<=(BasketLoss*(-1)) )
     {
      CloseEverything();
     }   
   
   AB   = AccountBalance();
   lots = NormalizeDouble(AB/Lotdivider, 2);
//---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
//---- RSI indicator
   rsi=iRSI(NULL,15,RSIperiod,PRICE_CLOSE,0); 
//---- Stochastic indicator
   stoch=iStochastic(NULL,15,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_MAIN,0);
//---- buy conditions UP
   if(rsi<RSILevel && stoch<StochLevel)  
     {
      sendbuy=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,Ask+Point*TP,"",MAGICMA,0,Blue);
      return;
     }

//----
  }

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+-----------------+
//| CloseEverythingBuy |
//+-----------------+
// Closes all OPEN and PENDING orders

int CloseEverything()
  {
   double myAsk;
   double myBid;
   int    myTkt;
   double myLot;
   int    myTyp;

   int i;
   bool result = false;
    
   for(i=OrdersTotal();i>=0;i--)
     {
      OrderSelect(i, SELECT_BY_POS);

      myAsk=MarketInfo(OrderSymbol(),MODE_ASK);            
      myBid=MarketInfo(OrderSymbol(),MODE_BID);            
      myTkt=OrderTicket();
      myLot=OrderLots();
      myTyp=OrderType();
            
      switch( myTyp )
        {
         //Close opened long positions
         case OP_BUY      :result = OrderClose(myTkt, myLot, myBid, Red);
         break;
      
         //Close opened short positions
         case OP_SELL     :result = OrderClose(myTkt, myLot, myAsk, Red);
         break;

         //Close pending orders
         case OP_BUYLIMIT :
         case OP_BUYSTOP  :
         case OP_SELLLIMIT:
         case OP_SELLSTOP :result = OrderDelete( OrderTicket() );
       }
    
      if(result == false)
        {
         Alert("Order " , myTkt , " failed to close. Error:" , GetLastError() );
         Print("Order " , myTkt , " failed to close. Error:" , GetLastError() );
         Sleep(3000);
        }  

      Sleep(1000);
      
     } //for
  
  } // closeeverything
   


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   CheckForOpen();
                                      
//----
  }
//+------------------------------------------------------------------+