//+------------------------------------------------------------------+
//|                                                  DropKickv11.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                    July 25, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  200607254
#include <stdlib.mqh>
#define     NL    "\n"

extern double PercentRisk     = 5;      // Will set trades until this percent of account in margin
extern bool WantBuys          = true;
extern bool WantSells         = true;
extern bool WantQuikPik       = false;  // Sets orders with a TP level
extern int MaxLotSize         = 0.1;    // largest lot size allowable. Will over ride programmed lot size
extern int MaxMargin          = 2000;   // set to maximum margin you will allow to be used
extern int TP                 = 35;     // Take profit level for QuickPik option
extern int vol                = 8;      // sets trades for this many ticks of current bar
extern int CloseAllAbove      = 1;      // closes all trades above this amount if close conditions are met
extern int RSIperiod          = 2;      // RSI setting on "shortterm" time frame
extern int UpperRSILevel      = 80;     // level for sells to take place
extern int LowerRSILevel      = 20;     // level for buys to take place
extern int ShortStochK        = 6;      // stochastic setting on "shortterm" time frame
extern int ShortStochD        = 3;      // stochastic setting on "shortterm" time frame
extern int ShortStochSlowing  = 2;      // stochastic setting on "shortterm" time frame
extern int LongStochK         = 70;     // stochastic setting on "longterm" time frame
extern int LongStochD         = 5;      // stochastic setting on "longterm" time frame
extern int LongStochSlowing   = 10;     // stochastic setting on "longterm" time frame
extern int UpperStochLevel    = 75;     // level for sells to take place
extern int LowerStochLevel    = 25;     // level for buys to take place
extern int shortterm          = 15;     // time frame that buys and sells take place on, 5 = 5 minutes, 30 = 30 minute, etc.
extern int longterm           = 60;     // time frame for longer term trend that allows for trading to occur 60 = hour, 240 = 4 hour, etc
extern int CloseBuyLevel      = 90;     // level where buys close when StochSignal begins to drop
extern int CloseSellLevel     = 10;     // level where sells close when tochSignal begins to rise

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int     sendbuy, sendsell, leveler;
   double  i, previousrsi, currentrsi, previousshortstoch, currentshortstoch;
   double  previouslongstoch, currentlongstoch, lots, modlots, AB, AE;
   double  buytakeprofit, selltakeprofit;
   
   AE   = AccountEquity();
   AB   = AccountBalance();
   if (AccountLeverage() == 100) lots = NormalizeDouble((AB*PercentRisk)/100000, 2);
   if (AccountLeverage() == 200) lots = NormalizeDouble((AB*PercentRisk)/10000, 2);
   if (lots < 0.01) lots = 0.01;
      
   if (WantQuikPik) 
     { 
      buytakeprofit = Ask+Point*TP;
      selltakeprofit = Bid+Point*TP;
     }
        
//---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
//---- RSI indicator
   currentrsi = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,0);
   previousrsi = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,1); 
 //---- short Stochastic indicator
   currentshortstoch  = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousshortstoch = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);

 //---- long Stochastic indicator
   currentlongstoch  = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previouslongstoch = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
  
 //---- lot modifications 
   modlots = NormalizeDouble(lots/2, 2);
   if(WantBuys && WantSells) lots = modlots;
   if(currentlongstoch < 30) lots = NormalizeDouble(lots*1.5, 2);
   if(currentlongstoch > 50 && currentlongstoch < 70) lots = NormalizeDouble(lots*0.5, 2);
   if(currentlongstoch < 30) modlots = NormalizeDouble(modlots*1.5, 2);
   if(currentlongstoch > 50 && currentlongstoch < 70) modlots = NormalizeDouble(modlots*0.5, 2);
   if(WantBuys && WantSells) lots = lots/2;
  
//---- buy conditions
  if(WantBuys)
   { 
    if(previouslongstoch < currentlongstoch && currentlongstoch < UpperRSILevel)  
     {
     if(currentrsi < LowerRSILevel && currentshortstoch < LowerStochLevel && previousshortstoch < currentshortstoch)  
      {
      sendbuy=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,buytakeprofit,"",MAGICMA,0,SteelBlue);
      return;
     }
    }
   } 
//---- sell conditions 
  if(WantSells)
   { 
    if(previouslongstoch > currentlongstoch && currentlongstoch > LowerRSILevel)  
     {
     if(currentrsi > UpperRSILevel && currentshortstoch > UpperStochLevel && previousshortstoch > currentshortstoch)  
      {
      sendsell=OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,selltakeprofit,"",MAGICMA,0,Orange);
      return;
     }
    }
   }     
//----
  }
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double previousstoch, currentstoch;
   int    sendclose, i, j, k, ticket, totalorders;
   string Name = "DropKickv11";
      
//---- Stochastic indicator
   currentstoch=iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousstoch=iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
//---- close buy conditions 
    if(currentstoch > CloseBuyLevel && previousstoch > currentstoch)  
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
         if (OrderType() == OP_BUY)
          { 
          if (OrderProfit() > CloseAllAbove) OrderClose(OrderTicket(),OrderLots(),Bid,0,Yellow);
          }
         }
       }
      return;
     }
    if(currentstoch < CloseSellLevel && previousstoch < currentstoch)
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
          if (OrderType() == OP_SELL)
          { 
          if (OrderProfit() > CloseAllAbove) OrderClose(OrderTicket(),OrderLots(),Ask,0,Yellow);
          }
         }
       }
      return;
     }
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   BuyProfit = BuyProfit + BuySwap;
   SellProfit = SellProfit + SellSwap;  
   TotalProfit = BuyProfit + SellProfit + BuySwap + SellSwap;
    
   CheckForClose();
   
   if (AccountLeverage() == 200) leveler = 4;    // for mini accounts
   if (AccountLeverage() == 100) leveler = 0.1;  // for standard accounts
   if (AccountLeverage() == 50)  leveler = 0.2;  // for standard accounts
   MaxLotsAllowed = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
   
   if(TotalLotsOpen > MaxLotsAllowed) return;
   if(OpenBuyLots >= MaxLotsAllowed/2) return;
   if(OpenSellLots >= MaxLotsAllowed/2) return;
   if(AccountMargin() > MaxMargin) return;
   if(AccountEquity() <= AccountBalance()/2) return;
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+