//+------------------------------------------------------------------+
//|                                                  DropKickv17.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                   August 1, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060801
#include <stdlib.mqh>
#define     NL    "\n"

extern double PercentRisk     = 5;     // TOTAL PERCENT RISK FOR ACCOUNT if SplitRisk=false;
extern bool SplitTheRisk      = true;  // Caution: assigns PercentRisk to EACH currency
extern double LotDivider      = 40;     // divides max lots by this number, lower = bigger lots
extern double LargestLotAllowed = 10;    // largest lot allowed to open, overrides program
extern bool WantShortBuys     = true;
extern bool WantShortSells    = false;
extern bool WantLongBuys      = true;
extern bool WantLongSells     = false;
extern int TradingMode        = 3;      // Mode 1=Stoch close, No short trades; 
                                        //      2=TP, No short trades;
                                        //      3=Stoch close plus short trades;
                                        //      4=TP plus short trades;
                                        //      5=short trades only; 
extern int ShortTakeProfit    = 10;     // Take profit level for short trades
extern int LongTakeProfit     = 30;     // Take profit level for long trades
extern int vol                = 3;      // sets trades for this many ticks of current bar
extern int CloseAllAbove      = 0.1;    // closes all trades above this amount if close conditions are met
extern int RSIperiod          = 3;      // RSI setting on "shortterm" time frame
extern int UpperRSILevel      = 75;     // level for sells to take place
extern int LowerRSILevel      = 25;     // level for buys to take place
extern int ShortStochK        = 10;     // stochastic setting on "shortterm" time frame
extern int ShortStochD        = 3;      // stochastic setting on "shortterm" time frame
extern int ShortStochSlowing  = 2;      // stochastic setting on "shortterm" time frame
extern int LongStochK         = 60;     // stochastic setting on "longterm" time frame
extern int LongStochD         = 5;      // stochastic setting on "longterm" time frame
extern int LongStochSlowing   = 10;     // stochastic setting on "longterm" time frame
extern int UpperStochLevel    = 75;     // level for sells to take place
extern int LowerStochLevel    = 25;     // level for buys to take place
extern int shortterm          = 5;      // time frame that buys and sells take place on, 5 = 5M
extern int mediumterm         = 15;     // time frame that buys and sells take place on, 5 = 5M, 30 = 30M, etc.
extern int longterm           = 60;     // time frame for longer term trend that allows for trading to occur 
extern int CloseBuyLevel      = 90;     // level where buys close when StochSignal begins to drop
extern int CloseSellLevel     = 10;     // level where sells close when tochSignal begins to rise
extern int startbuy           = 5;      // allows trading when longstoch gets below this level
extern int startsell          = 95;     // allows trading when longstoch gets above this level

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double  sendbuy, sendsell, leveler, lotcost, maxlots, lots, AB, AE;
   double  i, previousshortrsi, currentshortrsi, previousmediumrsi, currentmediumrsi;
   double  previousshortstoch, currentshortstoch, previousmediumstoch, currentmediumstoch;
   double  previouslongstoch, currentlongstoch, LbuyTP, LsellTP, SbuyTP, SsellTP, maxmargin;
               
   if (TradingMode == 2 || TradingMode ==4) 
     { 
      LbuyTP  = Ask+Point*LongTakeProfit;
      LsellTP = Bid-Point*LongTakeProfit;
     } 
   if (TradingMode == 5) 
     { 
      SbuyTP  = Ask+Point*ShortTakeProfit;
      SsellTP = Bid-Point*ShortTakeProfit;
     }    
 //---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
 //---- RSI indicator
   currentshortrsi  = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,0);
   previousshortrsi = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,1); 
 //---- short Stochastic indicator
   currentshortstoch  = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousshortstoch = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   
 //---- RSI indicator
   currentmediumrsi  = iRSI(NULL,mediumterm,RSIperiod,PRICE_CLOSE,0);
   previousmediumrsi = iRSI(NULL,mediumterm,RSIperiod,PRICE_CLOSE,1); 
 //---- short Stochastic indicator
   currentmediumstoch  = iStochastic(NULL,mediumterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousmediumstoch = iStochastic(NULL,mediumterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);

 //---- long Stochastic indicator
   currentlongstoch  = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previouslongstoch = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
  
 //---- lot setting and modifications
   AE   = AccountEquity();
   AB   = AccountBalance();
   if (AccountLeverage() == 100) lotcost = 1000;
   if (AccountLeverage() == 200) lotcost = 50;
   maxmargin = NormalizeDouble(AB*(PercentRisk/100), 0);
   maxlots = NormalizeDouble(maxmargin/lotcost, 2);
   lots = NormalizeDouble(maxlots/LotDivider, 2);
      
   if(WantLongBuys && !WantLongSells || WantShortBuys && !WantShortSells) 
     {
     if(currentlongstoch < 30) lots = NormalizeDouble(lots*2, 2);
     if(currentlongstoch > 50 && currentlongstoch < 70) lots = NormalizeDouble(lots*0.5, 2);
     }
   if(!WantLongBuys && WantLongSells) 
     {
     if(currentlongstoch > 70) lots = NormalizeDouble(lots*2, 2);
     if(currentlongstoch > 30 && currentlongstoch < 50) lots = NormalizeDouble(lots*0.5, 2);
     }
   if (WantLongBuys && WantLongSells || WantShortBuys && !WantShortSells) lots = NormalizeDouble(lots/2, 2);
   if (lots < 0.01) lots = 0.01;
   if (lots > LargestLotAllowed) lots = LargestLotAllowed;
  
//---- buy conditions
  if (TradingMode <= 4)
  {
  if(WantLongBuys)
   { 
    if(currentlongstoch < startbuy || previouslongstoch < currentlongstoch && currentlongstoch < 70)  
     {
     if(previousmediumrsi < currentmediumrsi && currentmediumstoch < LowerStochLevel && previousmediumstoch < currentmediumstoch)  
      {
      sendbuy=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,LbuyTP,"",MAGICMA,0,SteelBlue);
      return;
      }
     }
   } 
//---- sell conditions 
  if(WantLongSells)
   { 
    if(currentlongstoch > startsell || previouslongstoch > currentlongstoch && currentlongstoch > 30)  
     {
     if(previousmediumrsi > currentmediumrsi && currentmediumstoch > UpperStochLevel && previousmediumstoch > currentmediumstoch)  
      {
      sendsell=OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,LsellTP,"",MAGICMA,0,Orange);
      return;
      }
     }
    }
   }
   
if (TradingMode >= 3)
  {
  if(WantShortBuys)
   { 
    if(previousshortrsi < currentshortrsi && currentshortstoch < LowerStochLevel && previousshortstoch < currentshortstoch)  
      {
      sendbuy=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,SbuyTP,"",MAGICMA,0,DarkSeaGreen);
      return;
      }
   } 
//---- sell conditions 
  if(WantShortSells)
   { 
    if(previousshortrsi > currentshortrsi && currentshortstoch > UpperStochLevel && previousshortstoch > currentshortstoch)  
      {
      sendsell=OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,SsellTP,"",MAGICMA,0,LightSalmon);
      return;
      }
    } 
  }  
//----
  }
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double previousstoch, currentstoch;
   int    sendclose, i, j, k, ticket, totalorders;
   string Name = "DropKickv17";
      
//---- Stochastic indicator
   currentstoch  =iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousstoch =iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
//---- close buy conditions 
    if(currentstoch > CloseBuyLevel && previousstoch > currentstoch)  
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
         if (OrderType() == OP_BUY)
          { 
          if (OrderProfit() > CloseAllAbove) OrderClose(OrderTicket(),OrderLots(),Bid,0,Yellow);
          }
         }
       }
      return;
     }
    if(currentstoch < CloseSellLevel && previousstoch < currentstoch)
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
          if (OrderType() == OP_SELL)
          { 
          if (OrderProfit() > CloseAllAbove) OrderClose(OrderTicket(),OrderLots(),Ask,0,Yellow);
          }
         }
       }
      return;
     }
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   double  lotcost, maxlots, maxmargin, lots, AB, AE;
   
   AE   = AccountEquity();
   AB   = AccountBalance();
   if (AccountLeverage() == 100) lotcost = 1000;
   if (AccountLeverage() == 200) lotcost = 50;
   maxmargin = NormalizeDouble(AB*(PercentRisk/100), 0);
   maxlots = NormalizeDouble(maxmargin/lotcost, 2);
   lots = NormalizeDouble(maxlots/LotDivider, 2);
   
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   BuyProfit = BuyProfit + BuySwap;
   SellProfit = SellProfit + SellSwap;  
   TotalProfit = BuyProfit + SellProfit + BuySwap + SellSwap;
    
   CheckForClose();
   
   if (AccountLeverage() == 200) leveler = 4;    // for mini accounts
   if (AccountLeverage() == 100) leveler = 0.1;  // for standard accounts
   if (AccountLeverage() == 50)  leveler = 0.2;  // for standard accounts
   if(SplitTheRisk) 
      { OpenLots = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
      if(OpenLots > OpenLots) return;
      if(lots + TotalLotsOpen > OpenLots) return;
      if(TotalLotsOpen > OpenLots) return;
      if(OpenBuyLots >= OpenLots/2) return;
      if(OpenSellLots >= OpenLots/2) return;
      }
     
   if (!SplitTheRisk) 
      { MaxLotsAllowed = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
      if(OpenLots > MaxLotsAllowed) return;
      if(lots + TotalLotsOpen > MaxLotsAllowed) return;
      if(TotalLotsOpen > MaxLotsAllowed) return;
      if(OpenBuyLots >= MaxLotsAllowed/2) return;
      if(OpenSellLots >= MaxLotsAllowed/2) return;
      }
   if(AccountEquity() <= AccountBalance()/2) return;
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+