//+------------------------------------------------------------------+
//|                                                  DropKickv19.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                   August 7, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060807
#include <stdlib.mqh>
#define     NL    "\n"

extern double PercentRisk       = 8;      // TOTAL PERCENT RISK FOR ACCOUNT if SplitRisk=false;
extern bool   SplitTheRisk      = false;  // Caution: assigns PercentRisk to EACH currency
extern double ratio             = 0.001; 
extern double LotDivider        = 40;     // divides max lots by this number, lower = bigger lots
extern double LargestLotAllowed = 0.5;    // largest lot allowed to open, overrides program
extern bool WantLongBuys        = true;
extern bool WantLongSells       = false;
extern bool WantBreakouts       = true;
extern int  BOspread            = 8;
extern int  BOvol               = 2;
extern int  BOtp                = 16; 
extern int  TradingMode         = 4;      // Mode 1=Stoch close, No short trades; 
                                          //      2=TP, No short trades;
                                          //      3=Stoch close plus short trades;
                                          //      4=TP plus short trades;
                                          //      5=short trades only; 
extern int ShortTakeProfit      = 16;      // Take profit level for short trades
extern int LongTakeProfit       = 40;      // Take profit level for long trades
extern int vol                  = 3;      // sets trades for this many ticks of current bar
extern int CloseAllAbove        = 0.1;    // closes all trades above this amount if close conditions are met
extern int shortterm            = 5;      // time frame that buys and sells take place on, 5 = 5M
extern int mediumterm           = 15;     // time frame that buys and sells take place on, 5 = 5M, 30 = 30M, etc.
extern int longterm             = 60;     // time frame for longer term trend that allows for trading to occur 
extern int CloseBuyLevel        = 95;     // level where buys close when StochSignal begins to drop
extern int CloseSellLevel       = 15;     // level where sells close when tochSignal begins to rise
extern int startbuy             = 15;     // allows trading when longstoch gets below this level
extern int startsell            = 95;     // allows trading when longstoch gets above this level

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }


//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           //if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  } 
  
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           //if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  } 
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders;
   double  TotalProfit, BuyProfit, SellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit();
         if (OrderType() == OP_SELL) SellProfit +=  OrderProfit();
        }
     }
   TotalProfit = BuyProfit + SellProfit;
    
  //---- close buy conditions 
    if(SellProfit/AccountBalance() >= ratio) CloseAllThisSymbolSell(); 
    if(BuyProfit/AccountBalance() >= ratio) CloseAllThisSymbolBuy();
    
    return;
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int RSIperiod          = 3;      // RSI setting on "shortterm" time frame
   int UpperRSILevel      = 78;     // level for sells to take place
   int LowerRSILevel      = 22;     // level for buys to take place
   int ShortStochK        = 14;     // stochastic setting on "shortterm" time frame
   int ShortStochD        = 4;      // stochastic setting on "shortterm" time frame
   int ShortStochSlowing  = 2;      // stochastic setting on "shortterm" time frame
   int MedStochK          = 6;      // stochastic setting on "mediumterm" time frame
   int MedStochD          = 3;      // stochastic setting on "mediumterm" time frame
   int MedStochSlowing    = 2;      // stochastic setting on "mediumterm" time frame
   int LongStochK         = 40;     // stochastic setting on "longterm" time frame
   int LongStochD         = 10;     // stochastic setting on "longterm" time frame
   int LongStochSlowing   = 12;     // stochastic setting on "longterm" time frame
   int UpperStochLevel    = 75;     // level for sells to take place
   int LowerStochLevel    = 25;     // level for buys to take place
   int SShift             = 9;      // shifts the short stochastic level this amount
   double  sendbuy, sendsell, leveler, lotcost, maxlots, lots, AB, AE;
   double  i, previousshortrsi, currentshortrsi, previousmediumrsi, currentmediumrsi;
   double  previousshortstoch, currentshortstoch, previousmediumstoch, currentmediumstoch;
   double  previouslongstoch, currentlongstoch, LbuyTP, LsellTP, SbuyTP, SsellTP, maxmargin;
   double  MA0 = iMA(NULL,5,5,0,MODE_LWMA,PRICE_CLOSE,0);
   double  MA1 = iMA(NULL,5,5,0,MODE_LWMA,PRICE_CLOSE,1);
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   bool  WantShortBuys = true;
   bool  WantShortSells = true;
                 
   if (TradingMode == 2 || TradingMode ==4) 
     { 
      LbuyTP  = Ask+Point*LongTakeProfit;
      LsellTP = Bid-Point*(LongTakeProfit/2);
     } 
   if (TradingMode >= 3) 
     { 
      SbuyTP  = Ask+Point*ShortTakeProfit;
      SsellTP = Bid-Point*(ShortTakeProfit/2);
     }    
 //---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
 //---- RSI indicator
   currentshortrsi  = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,0);
   previousshortrsi = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,1); 
 //---- short Stochastic indicator
   currentshortstoch  = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousshortstoch = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
 //---- RSI indicator
   currentmediumrsi  = iRSI(NULL,mediumterm,RSIperiod,PRICE_CLOSE,0);
   previousmediumrsi = iRSI(NULL,mediumterm,RSIperiod,PRICE_CLOSE,1); 
 //---- short Stochastic indicator
   currentmediumstoch  = iStochastic(NULL,mediumterm,MedStochK,MedStochD,MedStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previousmediumstoch = iStochastic(NULL,mediumterm,MedStochK,MedStochD,MedStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
 //---- long Stochastic indicator
   currentlongstoch  = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,0);
   previouslongstoch = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
 //---- lot setting and modifications
   AE   = AccountEquity();
   AB   = AccountBalance();
   if(PercentRisk > 15) PercentRisk = 15;
   if (AccountLeverage() == 100) lotcost = 1000;
   if (AccountLeverage() == 200) lotcost = 50;
   maxmargin = NormalizeDouble(AB*(PercentRisk/100), 0);
   maxlots = NormalizeDouble(maxmargin/lotcost, 2);
   lots = NormalizeDouble(maxlots/LotDivider, 2);
      
   if(WantLongBuys && !WantLongSells || WantShortBuys && !WantShortSells) 
     {
     if(currentlongstoch < 30) lots = NormalizeDouble(lots*2, 2);
     if(currentlongstoch > 50 && currentlongstoch < 70) lots = NormalizeDouble(lots*0.5, 2);
     }
   if(!WantLongBuys && WantLongSells) 
     {
     if(currentlongstoch > 70) lots = NormalizeDouble(lots*2, 2);
     if(currentlongstoch > 30 && currentlongstoch < 50) lots = NormalizeDouble(lots*0.5, 2);
     }
   if (WantLongBuys && WantLongSells) lots = NormalizeDouble(lots/2, 2);
   if (lots < 0.01) lots = 0.01;
   if (lots > LargestLotAllowed) lots = LargestLotAllowed;
   
//---- breakout conditions   
 
    if(WantBreakouts)
     {
      if(Volume[0]>BOvol) return;
      if(Ask-Bid > BOspread*Point && MA0 < MA1) OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,Ask+BOtp*Point,"",MAGICMA,0,LimeGreen);
      if(Ask-Bid > BOspread*Point && MA0 > MA1) OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,Bid-(BOtp/2)*Point,"",MAGICMA,0,Magenta);
     }
     
//---- buy conditions
  if (TradingMode <= 4)
  {
  if(WantLongBuys)
   { 
    if(currentlongstoch < startbuy || previouslongstoch < currentlongstoch && currentlongstoch < 70)  
     {
     if(previousmediumrsi < currentmediumrsi && currentmediumstoch < LowerStochLevel && previousmediumstoch < currentmediumstoch)  
      {
      OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,LbuyTP,"",MAGICMA,0,Blue);
      return;
      }
     }
   } 
//---- sell conditions 
  if(WantLongSells)
   { 
    if(currentlongstoch > startsell || previouslongstoch > currentlongstoch && currentlongstoch > 30)  
     {
     if(previousmediumrsi > currentmediumrsi && currentmediumstoch > UpperStochLevel && previousmediumstoch > currentmediumstoch)  
      {
      OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,LsellTP,"",MAGICMA,0,Orange);
      return;
      }
     }
    }
   }
   
if (TradingMode >= 3)
  {
  if(currentlongstoch < startbuy || previouslongstoch < currentlongstoch && currentlongstoch < 70)  
    { 
    WantShortBuys=true;
    if(previousmediumstoch < currentmediumstoch && previousmediumrsi < currentmediumrsi)  
      {
     if(previousshortrsi < currentshortrsi && currentshortstoch < LowerStochLevel+SShift && previousshortstoch < currentshortstoch)  
       {
       OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,SbuyTP,"",MAGICMA,0,DarkSeaGreen);
       return;
       }
     } 
   } 
//---- sell conditions 
  if(currentlongstoch > startsell || previouslongstoch > currentlongstoch && currentlongstoch > 30)  
    {
    WantShortSells = true;
    if(previousmediumstoch > currentmediumstoch && previousmediumrsi > currentmediumrsi)  
      {
     if(previousshortrsi > currentshortrsi && currentshortstoch > UpperStochLevel-SShift && previousshortstoch > currentshortstoch)  
       {
       OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,SsellTP,"",MAGICMA,0,LightSalmon);
       return;
       }
      }
    }   
  }
   
//----
  }
  

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   double  lotcost, maxlots, maxmargin, lots, AB, AE;
   
   AE   = AccountEquity();
   AB   = AccountBalance();
   if (AccountLeverage() == 100) lotcost = 1000;
   if (AccountLeverage() == 200) lotcost = 50;
   maxmargin = NormalizeDouble(AB*(PercentRisk/100), 0);
   maxlots = NormalizeDouble(maxmargin/lotcost, 2);
   lots = NormalizeDouble(maxlots/LotDivider, 2);
   
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   TotalProfit = BuyProfit + SellProfit;
    
   CheckForClose();
   
   if (AccountLeverage() == 200) leveler = 4;    // for mini accounts
   if (AccountLeverage() == 100) leveler = 0.1;  // for standard accounts
   if (AccountLeverage() == 50)  leveler = 0.2;  // for standard accounts
   if(SplitTheRisk) 
      { 
      OpenLots = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
      if(lots + TotalLotsOpen > OpenLots) return;
      if(TotalLotsOpen > OpenLots) return;
      if(WantLongBuys && WantLongSells)
        {
        if(OpenBuyLots >= OpenLots/2) return;
        if(OpenSellLots >= OpenLots/2) return;
        }
      }
     
   if (!SplitTheRisk) 
      { 
      MaxLotsAllowed = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
      if(OpenLots > MaxLotsAllowed) return;
      if(lots + TotalLotsOpen > MaxLotsAllowed) return;
      if(TotalLotsOpen > MaxLotsAllowed) return;
      if(WantLongBuys && WantLongSells)
        {
        if(OpenBuyLots >= MaxLotsAllowed/2) return;
        if(OpenSellLots >= MaxLotsAllowed/2) return;
        }
      }
   if(AccountEquity() <= AccountBalance()/2) return;
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+