//+------------------------------------------------------------------+
//|                                                   DropKickv5.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                    July 19, 2006 |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#define MAGICMA  20060719
#define     NL    "\n" 

extern int TP                 = 70;
extern int RSIperiod          = 4;
extern int RSILevel           = 20;
extern int StochK             = 4;
extern int StochD             = 3;
extern int StochSlowing       = 2;
extern int StochLevel         = 20;
extern int vol                = 4;
extern int Lotdivider         = 17000; //Optimize for each currency
extern bool AccountIsMini     = true;  // Change to true if trading mini account
extern bool MoneyManagement   = true;  // Change to false to shutdown money management controls.
                                       // Lots = 1 will be in effect and only 1 lot will be open regardless of equity.
extern double Riskpercent     = 10;    // Change to whatever percent of equity you wish to risk.
extern double Margincutoff    = 800;   // Expert will stop trading if equity level decreases to that level.
extern double MaxLots         = 100;
extern double Lots            = 1;

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double rsi, stoch, lots, AE, lotMM;
   int    sendbuy;
 
lots = NormalizeDouble(AE/Lotdivider, 2); 
AE   = AccountEquity();

 
//---- select lot size
   double lot=NormalizeDouble(MathFloor(AccountBalance()*Riskpercent/10000)/10,1);
// lot at this point is number of standard lots
// Check if mini or standard Account
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
// Use at least 1 mini lot
   if(lot<0.01) lot=0.01;
  }else
  {
    if (lot < 0.1) lot = 0.1;
    if (lot > MaxLots) lot = MaxLots;
  }
  
   if(MoneyManagement)lotMM = lot;
   else {
     lotMM = lots;
     if(AccountIsMini)
     {
       if (lotMM > 1.0) lotMM = lotMM / 10;
       if (lotMM < 0.1) lotMM = 0.1;
     }
   }  
    
//---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
//---- RSI indicator
   rsi=iRSI(NULL,15,RSIperiod,PRICE_CLOSE,0); 
//---- Stochastic indicator
   stoch=iStochastic(NULL,15,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_MAIN,0);
//---- buy conditions UP
   if(rsi<RSILevel && stoch<StochLevel)  
     {
      sendbuy=OrderSend(Symbol(),OP_BUY,lotMM,Ask,3,0,Ask+Point*TP,"",MAGICMA,0,Blue);
      return;
     }

//----
  }

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
  if(AccountFreeMargin() < Margincutoff) return(0);
   
   double  ProfitTarget, i;
   double  OpenBuyLots, BuyOrders;
   double  TotalProfit, BuyProfit, Swap;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);       

//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
   
//+------------------------------------------------------------------+
//|  Determine Open Orders/Lots and Pending Orders this Symbol       |
//+------------------------------------------------------------------+
           
    for(i = 0; i < OrdersTotal(); i++)
      {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           Swap += OrderSwap();
          }
        }
      }
  
    TotalProfit = BuyProfit + Swap;
    
//---- calculate open orders by current symbol
   CheckForOpen();
                                      
//----

Comment(" BuyOrders ", BuyOrders,NL,
        " OpenBuyLots ", OpenBuyLots,NL,
        " TotalProfit ", TotalProfit,NL,
        " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+