//+------------------------------------------------------------------+
//|                                                   DropKickv7.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                    July 20, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060720
#include <stdlib.mqh>
#define     NL    "\n"

extern int TakeProfit         = 5;
extern int RSIperiod          = 2;
extern int RSILevel           = 30;
extern int ShortStochK        = 4;
extern int ShortStochD        = 3;
extern int ShortStochSlowing  = 2;
extern int LongStochK         = 70;
extern int LongStochD         = 10;
extern int LongStochSlowing   = 10;
extern int UpperStochLevel    = 83;
extern int LowerStochLevel    = 22;
extern int vol                = 4;
extern int Lotdivider         = 8000;
extern double PercentRisk     = 30;   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int     sendbuy, leveler;
   double  i, rsi, shortstoch, lots, AE;
   double  previousstoch, currentstoch;
   
   AE   = AccountEquity();
   lots = NormalizeDouble(AE/Lotdivider, 2);  
              
//---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
//---- RSI indicator
   rsi = iRSI(NULL,15,RSIperiod,PRICE_CLOSE,0); 
//---- Stochastic indicator
   shortstoch = iStochastic(NULL,15,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_MAIN,0);
//---- buy conditions UP
   //---- Stochastic indicator
   currentstoch  = iStochastic(NULL,60,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,0);
   previousstoch = iStochastic(NULL,60,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,1);
//---- buy conditions UP
   if(previousstoch < currentstoch && currentstoch < UpperStochLevel)  
     {
     if(rsi < RSILevel && shortstoch < LowerStochLevel)  
      {
      sendbuy=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"",MAGICMA,0,Blue);
      return;
     }
    }
//----
  }
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                  |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double previousstoch, currentstoch;
   int    sendclose, i, j, k, ticket, totalorders;
   string Name = "DropKickv7";
      
//---- Stochastic indicator
   currentstoch=iStochastic(NULL,60,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,0);
   previousstoch=iStochastic(NULL,60,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,1);
//---- buy conditions UP
   if(previousstoch > UpperStochLevel && currentstoch < UpperStochLevel)  
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         {  
          if (OrderProfit() > TakeProfit) OrderClose(OrderTicket(),OrderLots(),Bid,0,Yellow);
         }
       }
      return;
    }
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
   
   double  i, OpenBuyLots, BuyOrders, leveler;
   double  TotalProfit, BuyProfit, Swap;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           Swap += OrderSwap();
          }
        }
     }
   TotalProfit = BuyProfit + Swap;
    
   CheckForClose();
   
   if (AccountLeverage() == 200) leveler = 4;    // for mini accounts
   if (AccountLeverage() == 100) leveler = 0.1;  // for standard accounts
   if (AccountLeverage() == 50)  leveler = 0.2;  // for standard accounts
    
   double MaxLotsAllowed = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
   if(OpenBuyLots > MaxLotsAllowed) return;
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+