//+------------------------------------------------------------------+
//|                                                   DropKickv8.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                    July 21, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060721
#include <stdlib.mqh>
#define     NL    "\n"

extern double PercentRisk     = 20;     // Will set trades until this percent of account in margin
extern bool WantBuys          = true;
extern bool WantSells         = false;
extern int MaxMargin          = 600;    // set to maximum margin you will allow to be used
extern int vol                = 4;      // sets trades for this many ticks of current bar
extern int TakeProfit         = 1;      // closes all trades above this amount if close conditions are met
extern int RSIperiod          = 2;      // RSI setting on "shortterm" time frame
extern int UpperRSILevel      = 70;     // level for sells to take place
extern int LowerRSILevel      = 30;     // level for buys to take place
extern int ShortStochK        = 4;      // stochastic setting on "shortterm" time frame
extern int ShortStochD        = 3;      // stochastic setting on "shortterm" time frame
extern int ShortStochSlowing  = 2;      // stochastic setting on "shortterm" time frame
extern int LongStochK         = 70;     // stochastic setting on "longterm" time frame
extern int LongStochD         = 10;     // stochastic setting on "longterm" time frame
extern int LongStochSlowing   = 10;     // stochastic setting on "longterm" time frame
extern int UpperStochLevel    = 80;     // level for sells to take place
extern int LowerStochLevel    = 20;     // level for buys to take place
extern int shortterm          = 15;     // time frame that buys and sells take place on, 5 = 5 minutes, 30 = 30 minute, etc.
extern int longterm           = 60;     // time frame for longer term trend that allows for trading to occur 60 = hour, 240 = 4 hour, etc
extern int CloseBuyLevel      = 85;     // level where buys close when LongStochK drops below
extern int CloseSellLevel     = 15;     // level where sells close when LongStochK rises above

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int     sendbuy, sendsell, leveler;
   double  i, rsi, stoch, lots, AE, Lotdivider;
   double  previousstoch, currentstoch;
   
   Lotdivider = NormalizeDouble(AccountBalance()*2, 0);
   AE   = AccountEquity();
   lots = NormalizeDouble(AE/Lotdivider, 2);  
              
//---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
//---- RSI indicator
   rsi = iRSI(NULL,shortterm,RSIperiod,PRICE_CLOSE,0); 
//---- Stochastic indicator
   stoch = iStochastic(NULL,shortterm,ShortStochK,ShortStochD,ShortStochSlowing,MODE_LWMA,0,MODE_MAIN,0);
//---- buy conditions UP
 //---- Stochastic indicator
   currentstoch  = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,0);
   previousstoch = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,1);
//---- buy conditions
  if(WantBuys)
   { 
   if(previousstoch < currentstoch && currentstoch < UpperStochLevel)  
     {
     if(rsi < LowerRSILevel && stoch < LowerStochLevel)  
      {
      sendbuy=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"",MAGICMA,0,Blue);
      return;
     }
    }
   } 
//---- sell conditions 
  if(WantSells)
   { 
   if(previousstoch > currentstoch && currentstoch > LowerStochLevel)  
     {
     if(rsi > UpperRSILevel && stoch > UpperStochLevel)  
      {
      sendsell=OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"",MAGICMA,0,Maroon);
      return;
     }
    }
   }     
//----
  }
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double previousstoch, currentstoch;
   int    sendclose, i, j, k, ticket, totalorders;
   string Name = "DropKickv8";
      
//---- Stochastic indicator
   currentstoch=iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,0);
   previousstoch=iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_MAIN,1);
//---- close buy conditions 
    if(previousstoch > UpperStochLevel && currentstoch < UpperStochLevel)  
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
         if (OrderType() == OP_BUY)
          { 
          if (OrderProfit() > TakeProfit) OrderClose(OrderTicket(),OrderLots(),Bid,0,Yellow);
          }
         }
       }
      return;
     }
    if(previousstoch < LowerStochLevel && currentstoch > LowerStochLevel)
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
          if (OrderType() == OP_SELL)
          { 
          if (OrderProfit() > TakeProfit) OrderClose(OrderTicket(),OrderLots(),Ask,0,Yellow);
          }
         }
       }
      return;
     }
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   BuyProfit = BuyProfit + BuySwap;
   SellProfit = SellProfit + SellSwap;  
   TotalProfit = BuyProfit + SellProfit + BuySwap + SellSwap;
    
   CheckForClose();
   
   if (AccountLeverage() == 200) leveler = 4;    // for mini accounts
   if (AccountLeverage() == 100) leveler = 0.1;  // for standard accounts
   if (AccountLeverage() == 50)  leveler = 0.2;  // for standard accounts
   MaxLotsAllowed = ((AccountBalance()/AccountLeverage())*(PercentRisk/100))*leveler;
   
   if(TotalLotsOpen > MaxLotsAllowed) return;
   if(AccountMargin() > MaxMargin) return;
   if(AccountEquity() <= AccountBalance()/2) return;
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+