//+------------------------------------------------------------------+
//|                                                    SpeedEnvy.mq4 |
//|                   Copyright  2005, Alejandro Galindo & KMRUNNER |
//|                                              http://elCactus.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Alejandro Galindo"
#property link      "http://elCactus.com"

extern double Lots            = 1;
extern double ratio           = 0.003;
extern int    MaxTrades       = 50;
extern int    TimeFrame       = 60;
extern int    LWMA            = 125;
extern int    MinutesBetween  = 1;
extern int    BigBarPips      = 50;
extern double Dev1            = 0.4;
extern double Dev2            = 0.6;
extern double Dev3            = 0.8;

extern double EURUSDPipValue  = 10;
extern double GBPUSDPipValue  = 10;
extern double USDCHFPipValue  = 10;
extern double USDJPYPipValue  = 9.715;
extern int mm                 = 0;
extern int risk               = 12;
extern int AccountisNormal    = 0;

int  OpenOrders=0, cnt=0;
int  slippage=5;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int mode=0, myOrderType=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0, LastBuyTime, LastSellTime;
double LastClosePrice=0, LastLots=0;
double Pivot=0;
double PipValue=0;
string text="", text2="";
bool AllowTrades = true;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           //if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           //if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders;
   double  TotalProfit, BuyProfit, SellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)  BuyProfit +=  OrderProfit();
         BuyOrders ++;
         if (OrderType() == OP_SELL) SellProfit +=  OrderProfit();
         SellOrders ++;
        }
     }
   TotalProfit = BuyProfit + SellProfit;
    
  //---- close buy conditions 
     if(BuyProfit/AccountBalance() >= ratio) CloseAllThisSymbolBuy();
     if(SellProfit/AccountBalance() >= ratio) CloseAllThisSymbolSell();
     //if(TotalProfit/AccountBalance() >= ratio) CloseAllThisSymbol();
    
    return;
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 

   CheckForClose();
 
   int  BuyOrders, SellOrders;
   int  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   int  shift=iBarShift(NULL,15,OrderOpenTime(), true);  //to get the number of bars back to the Open Bar               

   double SellEnv1 = iEnvelopes(NULL, TimeFrame, LWMA, MODE_LWMA, 0, 0, Dev1, 1, 0);
   double SellEnv2 = iEnvelopes(NULL, TimeFrame, LWMA, MODE_LWMA, 0, 0, Dev2, 1, 0);
   double SellEnv3 = iEnvelopes(NULL, TimeFrame, LWMA, MODE_LWMA, 0, 0, Dev3, 1, 0);
   double BuyEnv1  = iEnvelopes(NULL, TimeFrame, LWMA, MODE_LWMA, 0, 0, Dev1, 2, 0);
   double BuyEnv2  = iEnvelopes(NULL, TimeFrame, LWMA, MODE_LWMA, 0, 0, Dev2, 2, 0);
   double BuyEnv3  = iEnvelopes(NULL, TimeFrame, LWMA, MODE_LWMA, 0, 0, Dev3, 2, 0);

   if (AccountisNormal==1)
   {
	  if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000); }
		else { lotsi=Lots; }
   } else {  // then is mini
    if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/10; }
		else { lotsi=Lots; }
   }

   if (lotsi>100){ lotsi=100; }
   
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol())
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol()) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=1; }
			BuyOrders ++;
			if (mode==OP_SELL) { myOrderType=4;	}
			SellOrders ++;
		 }
	  }
   }

   if (OpenOrders<1) 
   {
	  myOrderType=9;
	} 

	  if (Close[1] < BuyEnv1 && Ask>=BuyEnv1) { myOrderType=1; }
	  if (Close[1] < BuyEnv2 && Ask>=BuyEnv2) { myOrderType=2; }
 	  if (Close[1] < BuyEnv3 && Ask>=BuyEnv3) { myOrderType=3; }
  
     if (Bid >= Open[0]+BigBarPips*Point)    { myOrderType=3; }

 	  if (Close[1] > SellEnv1 && Bid<=SellEnv1) { myOrderType=4; }
	  if (Close[1] > SellEnv2 && Bid<=SellEnv2) { myOrderType=5; }
     if (Close[1] > SellEnv3 && Bid<=SellEnv3) { myOrderType=6; }
   
     if (Open[0]-Ask >= BigBarPips*Point)      { myOrderType=6; }

   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol()) 
	  {			
	  	   LastTicket=OrderTicket();
	  	   if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{
				LastBuyTime=OrderOpenTime();
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			}
			if (LastType==OP_SELL) 
			{
			   LastSellTime=OrderOpenTime();
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
			}
	  }
   }
	
      if (!IsTesting()) 
      {
	     if (myOrderType==9) { text="No conditions to open trades"; }
	     else { text="                         "; }
	     Comment("LastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\n",text2,"\nLots=",lotsi,"\n",text);
      }
      
	  if (myOrderType==1 && ContinueOpening) 
      {
	     if (LastBuyTime < Time[MinutesBetween/15] || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
				  else { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,0,0,NULL,0,0,LightBlue);		    
		    return(0);
	     }
      }
         
      if (myOrderType==2 && ContinueOpening) 
      {
	     if (LastBuyTime < Time[MinutesBetween/15] || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
				  else { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,0,0,NULL,0,0,Blue);		    
		    return(0);
	     }
      }
         
      if (myOrderType==3 && ContinueOpening) 
      {
	     if (LastBuyTime < Time[MinutesBetween/15] || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
				  else { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,0,0,NULL,0,0,Indigo);		    
		    return(0);
	     }
      }
         
     if (myOrderType==4 && ContinueOpening) 
      {	
	     if (LastSellTime < Time[MinutesBetween/15] || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
				     else { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,0,0,NULL,0,0,Magenta);		    		    
		    return(0);
	     }
      }
      
      if (myOrderType==5 && ContinueOpening) 
      {	
	     if (LastSellTime < Time[MinutesBetween/15] || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
				     else { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,0,0,NULL,0,0,Red);		    		    
		    return(0);
	     }
      }
      
      if (myOrderType==6 && ContinueOpening) 
      {	
	     if (LastSellTime < Time[MinutesBetween/15] || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
				     else { mylotsi=NormalizeDouble(mylotsi+0.02,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,0,0,NULL,0,0,Maroon);		    		    
		    return(0);
	     }
      }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+