//+------+
//|EnvyBollTrade - No Logging
//+------+
#property copyright "Ron Thompson"
#property link      "http://www.lightpatch.com/forex"

// user input
extern double ratio        =    0.0001;    // how much money do you expect to make
extern int    MA           =    50;
extern double Level1       =    0.03;
extern double Level2       =    0.06;
extern double Level3       =    0.09;
extern double Level4       =    0.12;
extern double Lots         =    0.4;         // how many lots to trade at a time 
extern bool   LotIncrease  =    true;      // grow lots based on balance = true
extern bool   OneOrderOnly =    false;     // one order at a time or not

// non-external flag settings
int    Slippage=2;                       // how many pips of slippage can you tolorate

// naming and numbering
int    MagicNumber  = 363638;            // allows multiple experts to trade on same account
string TradeComment = " envybollnolog.txt";
double StartingBalance = 0;                // lot size control if LotIncrease == true

// Bar handling
datetime bartime=0;                      // used to determine when a bar has moved
int      bartick=0;                      // number of times bars have moved

// Trade control
bool   TradeAllowed=true;                // used to manage trades


// Min/Max tracking and tick logging
int    maxOrders;                        // statistic for maximum numbers or orders open at one time
double maxEquity;                        // statistic for maximum equity level
double minEquity;                        // statistic for minimum equity level
double maxOEquity;                       // statistic for maximum equity level per order
double minOEquity;                       // statistic for minimum equity level per order 
double EquityPos=0;                      // statistic for number of ticks order was positive
double EquityNeg=0;                      // statistic for number of ticks order was negative
double EquityZer=0;                      // statistic for number of ticks order was zero

// used for verbose error logging
#include <stdlib.mqh>

//+-------------+
//| Custom init |
//|-------------+
// Called ONCE when EA is added to chart or recompiled

int init()
  {
   if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
// Called ONCE when EA is removed from chart

int deinit()
  {

  }
  
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  // only look if mygrid and symbol...
      {
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double  i, TotalProfit, BuyProfit, SellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {
         if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit();
         if (OrderType() == OP_SELL) SellProfit +=  OrderProfit();
        }
     }
   TotalProfit = BuyProfit + SellProfit;
    
  //---- close buy conditions 
    if(BuyProfit/AccountBalance() >= ratio) CloseAllThisSymbolBuy(); 
    if(SellProfit/AccountBalance() >= ratio) CloseAllThisSymbolSell(); 
    //if(TotalProfit/AccountBalance() >= ratio) CloseAllThisSymbolAll();
    
    return;
  }
//+-----------+
//| Main      |
//+-----------+
// Called EACH TICK and each Bar[]

int start()
  {

CheckForClose();

   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   int      OrdersPerSymbol=0;
   int      OrdersBUY=0;
   int      OrdersSELL=0;
  
   // stoploss and takeprofit and close control
   double BuyLotIncrease, SellLotIncrease, BuyLots, SellLots;
   
   // direction control
   bool BUYme = false;
   bool BUYme1=false;
   bool BUYme2=false;
   bool BUYme3=false;
   bool BUYme4=false;
   
   bool SELLme = false;
   bool SELLme1=false;
   bool SELLme2=false;
   bool SELLme3=false;
   bool SELLme4=false;

   // bar counting
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      bartick++; 
      TradeAllowed=true;
     }

   // Lot increasement based on AccountBalance when expert is started
   // this will trade 1.0, then 1.1, then 1.2 etc as account balance grows
   // or 0.9 then 0.8 then 0.7 as account balance shrinks 
   if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50.0) Lots=50.0;
     }

   OrdersPerSymbol=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
         if(OrderType()==OP_BUY) {OrdersBUY++;}
         if(OrderType()==OP_SELL){OrdersSELL++;}
        }
     }
    
     BuyLots = Lots;
     SellLots = Lots;
  
   // keep some statistics
   if(OrdersPerSymbol>maxOrders) maxOrders=OrdersPerSymbol;
     
   //+-----------------------------+
   //| Insert your indicator here  |
   //| And set either BUYme or     |
   //| SELLme true to place orders |
   //+-----------------------------+
   
   double Envy1Sell = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level1,MODE_UPPER,0);
   double Envy2Sell = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level2,MODE_UPPER,0);
   double Envy3Sell = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level3,MODE_UPPER,0);
   double Envy4Sell = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level4,MODE_UPPER,0);
  
   double Envy1Buy = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level1,MODE_LOWER,0);
   double Envy2Buy = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level2,MODE_LOWER,0);
   double Envy3Buy = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level3,MODE_LOWER,0);
   double Envy4Buy = iEnvelopes(NULL,0,MA,MODE_LWMA,0,MODE_CLOSE,Level4,MODE_LOWER,0);

   if(Close[0]>Envy1Sell && Close[0]<Envy2Sell) SELLme1=true;
   if(Close[0]>Envy2Sell && Close[0]<Envy3Sell) SELLme2=true;
   if(Close[0]>Envy3Sell && Close[0]<Envy4Sell) SELLme3=true;
   if(Close[0]>Envy4Sell) SELLme4=true;

   if(Close[0]<Envy1Buy && Close[0]>Envy2Buy)  BUYme1=true;
   if(Close[0]<Envy2Buy && Close[0]>Envy3Buy)  BUYme2=true;
   if(Close[0]<Envy3Buy && Close[0]>Envy4Buy)  BUYme3=true;
   if(Close[0]<Envy4Buy)  BUYme4=true;

   if(SELLme1) SELLme = SELLme1;
   if(SELLme2) {SellLots = Lots*2; SELLme = SELLme2;}
   if(SELLme3) {SellLots = Lots*3; SELLme = SELLme3;}
   if(SELLme4) {SellLots = Lots*4; SELLme = SELLme4;}
   
   if(BUYme1) BUYme = BUYme1;
   if(BUYme2) {BuyLots = Lots*2; BUYme = BUYme2;}
   if(BUYme3) {BuyLots = Lots*3; BUYme = BUYme3;}
   if(BUYme4) {BuyLots = Lots*4; BUYme = BUYme4;}
   
   //+------------+
   //| End Insert |
   //+------------+

   
   //ENTRY LONG (buy, Ask) 
   if( (OneOrderOnly && OrdersPerSymbol==0 && BUYme)||(!OneOrderOnly && TradeAllowed && BUYme) )
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_BUY,BuyLots,Ask,Slippage,0,0,TradeComment,MagicNumber,White);
         gle=GetLastError();
         if(gle==0)
           {
            maxOEquity=0;
            minOEquity=0;
            EquityPos=0;
            EquityNeg=0;
            EquityZer=0;
            TradeAllowed=false;
            break;
           }
        }//while   
     }//BUYme
        

   //ENTRY SHORT (sell, Bid)
   if( (OneOrderOnly && OrdersPerSymbol==0 && SELLme)||(!OneOrderOnly && TradeAllowed && SELLme) )
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_SELL,SellLots,Bid,Slippage,0,0,TradeComment,MagicNumber,Red);
         gle=GetLastError();
         if(gle==0)
           {
            maxOEquity=0;
            minOEquity=0;
            EquityPos=0;
            EquityNeg=0;
            EquityZer=0;
            TradeAllowed=false;
            break;
           }
        }//while
     }//SELLme
  } // start()

