//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|            F-22 Raptor
//|     Last Updated 2-7-2007 3:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern int    Profit              = 125;
extern int    EntryAbove          = 20;      // pips above open
extern int    SpacingAbove        = 5;
extern int    EntryBelow          = 90;      // pips below open
extern int    SpacingBelow        = 15;
extern double Lots                = 0.01;     // how many lots to trade at a time
extern double Weight              = 0.01;
extern bool   Boost               = true;    // buy more as the distance outside the band increases
extern bool   LotIncrease         = true;  
extern int    MaxTrades           = 25;
extern int    Orders              = 1;       // number of orders at Lots
extern bool   IsAcctMini          = false;
extern bool   UseAlerts           = false;
extern bool   CloseAllNow         = false;
extern bool   EndTrading          = false;   // closes EA after all trades close
extern bool   StopTrading         = false;   // Stops All trading but allows trades to close

int    Slippage                = 5;             // how many pips of slippage can you tolorate
bool   OneOrderOnly            = false ;        // one order at a time or not
double BoostTrack              = 0;             // used to track compounding and steps

int    MagicNumber             = 322727867;      // allows multiple experts to trade on same account
string TradeComment            = "F-22 Raptor";  // comment so multiple EAs can be seen in Account History
double StartingBalance  = 0;                     // lot size control if LotIncrease == true
bool   TradeAllowed            = true;           // used to manage trades
datetime    bartime            = 0;                    
int    StartHour1              = 0;
int    EndHour1                = 24;
int    SL                      = 1000;

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  double LastBuyTime;
  
  for(int i=totalorders-1;i>=0;i--)
    {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if (OrderType() == OP_BUY && OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
        if (OrderType() == OP_BUY && CurTime()-LastBuyTime >=120)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("CashReg2.wav");
      }
    }
  return; 
 }

//+------------------------------------------------------------------+
//| Check for BUY order conditions                                
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double   BuyOrders, LowestBuy=1000, HighestBuy;
   int      cnt=0;
   int      gle=0;

   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
         {
          if (OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
            {
              BuyOrders++;
              if(OrderOpenPrice()>HighestBuy) HighestBuy=OrderOpenPrice();
            }
         }
     }
     
    if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50 && IsAcctMini) Lots=50;
      if(Lots>100 && !IsAcctMini) Lots=100;
    }
     
   if(TradeAllowed && Bid >= HighestBuy+SpacingAbove*Point)
     {
        for(int i=1;i<Orders+1;i++)
         {
          OrderSend(Symbol(),OP_BUY,Lots+((BuyOrders*Weight)/Orders),Ask,Slippage,Ask-SL*Point,0,TradeComment,MagicNumber,Blue);
          if (UseAlerts) PlaySound("sound136.wav");
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for Counter BUY order conditions                                
//+------------------------------------------------------------------+
void CheckForCounterBuy()
  {
   double   BuyOrders, LowestBuy=1000;
   int      cnt=0;
   int      gle=0;

   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
         {
          if (OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
            {
              BuyOrders++;
              if(OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
            }
         }
     }
     
    if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50 && IsAcctMini) Lots=50;
      if(Lots>100 && !IsAcctMini) Lots=100;
    }
     
   if(TradeAllowed && Ask <= LowestBuy-SpacingBelow*Point)
     {
        for(int i=1;i<Orders+1;i++)
         {
          OrderSend(Symbol(),OP_BUY,Lots+((BuyOrders*Weight)/Orders),Ask,Slippage,Ask-SL*Point,0,TradeComment,MagicNumber,Blue);
          if (UseAlerts) PlaySound("sound136.wav");
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
   
//+--------------------------------------------------+
//|  Main Start Routine                              
//+--------------------------------------------------+
int start()
  {
   
   double   OrdersBUY, BuyTarget, Entry, LastBuyTime;
   double   BuyLots, BuyProfit, ProfitTarget, LargestMargin;
   double   HighestBuy, LowestBuy=1000;
   int      CurrentTime = TimeHour(CurTime());
   bool     BUYme=false;
   double   Stoch1 = iStochastic(NULL,60,100,22,1,MODE_LWMA,0,MODE_SIGNAL,0);
   double   Stoch2 = iStochastic(NULL,60,100,22,1,MODE_LWMA,0,MODE_SIGNAL,1);
   double   Spread = Ask-Bid;
   
   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_BUY && OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
              if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
              if(OrderType()==OP_BUY && OrderOpenPrice()>HighestBuy) HighestBuy=OrderOpenPrice();
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }
    
    if(OrdersBUY==0) HighestBuy=1000;
    
    if(CurrentTime >=0 && CurrentTime<5)   ProfitTarget = Profit*1;
    if(CurrentTime >=5 && CurrentTime<17)  ProfitTarget = Profit*0.5;
    if(CurrentTime >=17 && CurrentTime<20) ProfitTarget = Profit*1;
    if(CurrentTime >=20 && CurrentTime<24) ProfitTarget = Profit*1.5;

    BuyTarget = ProfitTarget * BuyLots;   
    
    if(!IsAcctMini)
      {
      BuyTarget = BuyTarget * 10;
      }
    
    if(BuyTarget < 50) BuyTarget = 50;
  
    if(Stoch1 > Stoch2) BuyTarget = BuyTarget *1.5;
 
    if(BuyProfit >= BuyTarget && CurTime()-LastBuyTime >=120) CloseAllThisSymbolBuy(); 

    if(CloseAllNow) CloseAllThisSymbolBuy();
     

  if(OrdersBUY < MaxTrades && CurrentTime >=StartHour1 && CurrentTime<EndHour1)  
    {
// Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Bid>=(Open[0]+(EntryAbove*Point)) || Bid>=HighestBuy+SpacingAbove*Point && Spread<=14)   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0)
         {
         BUYme=true;
         TradeAllowed=true;
         }
       }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForBuy();
   
// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<=(Open[0]-(EntryBelow*Point)) && Spread<=14 || Ask<=(Open[0]-(EntryBelow*Point)) && Ask<=LowestBuy-SpacingBelow*Point && Spread<=14)   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForCounterBuy();
 
  }
  
   Comment("                    F-22 Raptor Rev Last Update 2-7-2007 3:00pm", NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyLots        ", BuyLots, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL,
           "                            Margin              ", AccountMargin(), NL,
           "                            MarginPercent        ", MathRound((AccountEquity()/AccountMargin())*100), NL,
           "                            Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));   

 } // end start()

