//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|               Falcon 10 
//|   Last Updated 11-22-2006 10:00am
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double Lots           = 0.05;     // how many lots to trade at a time
extern double Weight         = 0.1;    // each new order increases this amount 
extern int    Orders         = 1;       // number of orders at Lots
extern double MaxLots        = 2;       // max number of Lots to set
extern int    TargetLevel    = 10;      // number of pips per lot for profit
extern int    TradeLevel     = 21;      // pips above or below open
extern int    Spacing        = 10;       // min distance above last high or below last low
extern int    MaxMargin      = 5000;    // maximum margin allowed
extern bool   UseAlerts      = true;
extern bool   LotIncrease    = true;  
extern bool   Boost          = true;    // buy more as the distance outside the band increases
extern bool   IsAcctMini     = false;
extern bool   EndTrading     = false;   // closes EA after all trades close
extern bool   StopTrading    = false;   // Stops All trading but allows trades to close
extern int    EndHour        = 24;      // stop trading after this time friday

int    Slippage        = 0;             // how many pips of slippage can you tolorate
bool   OneOrderOnly    = false ;        // one order at a time or not
double BoostTrack      = 0;             // used to track compounding and steps

int    MagicNumber     = 3252668;       // allows multiple experts to trade on same account
string TradeComment    = "_FALCON.txt"; // comment so multiple EAs can be seen in Account History
double StartingBalance = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed    = true;          // used to manage trades
datetime    bartime    = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {

  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| cancels all BUY positions                                              |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol()&& OrderMagicNumber()==MagicNumber)  
      {
        if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("CashReg2.wav");
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all SELL positions                                             |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol()&& OrderMagicNumber()==MagicNumber)
      {
        if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
         if (UseAlerts) PlaySound("CashReg2.wav");
     }
  }
  return; 
  }

//+------------------------------------------------------------------+
//| Check for BUY order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double   BuyOrders, LowestBuy=1000;
   int      cnt=0;
   int      gle=0;
   
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
        {
          if (OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
          BuyOrders++;
        }
     }
     
   if (Ask >= LowestBuy-(Spacing*Point)) return;
   if(TradeAllowed && Ask < LowestBuy-(Spacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,Lots+(BuyOrders*Weight),Ask,Slippage,0,0,TradeComment,MagicNumber,Blue);
        if (UseAlerts) PlaySound("sound7.wav");
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for SELL order conditions                                   |
//+------------------------------------------------------------------+
void CheckForSell()
  {
   double   SellOrders, HighestSell;
   int      cnt=0;
   int      gle=0;
      
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber)
        {
          if (OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
          SellOrders++;
        }
     } 
    
   if(TradeAllowed && Bid > HighestSell+(Spacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_SELL,Lots+(SellOrders*Weight),Bid,Slippage,0,0,TradeComment,MagicNumber,Orange);
        if (UseAlerts) PlaySound("alert.wav");
         }
         gle=GetLastError();
         if(gle==0)
           {
           BoostTrack=Close[0];
           TradeAllowed=false;
           }
       }
   }

//+--------------------------------------------------+
//|   Main                                           |
//+--------------------------------------------------+
int start()
  {
   
   double   i, OrdersSELL, OrdersBUY, BuyPips, SellPips;
   double   HighestSell, LowestBuy, BuyLots, SellLots, BuyProfit, SellProfit;
   double   CurrentTime = (TimeHour(CurTime()+TimeMinute(CurTime())));
   bool     SELLme=false;
   bool     BUYme=false;
  
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {
           if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
           if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
           if (OrderType() == OP_SELL) SellProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }
   
    BuyPips   = (TargetLevel * 10 * BuyLots); 
    SellPips  = (TargetLevel * 10 * SellLots); 
    
    if(BuyProfit  > BuyPips)  CloseAllThisSymbolBuy(); 
    if(SellProfit > SellPips) CloseAllThisSymbolSell();
      
   Comment("                    Falcon 10 Last Update 11-22-2006 10:00am", NL,
           "                    Sells ", OrdersSELL, NL,
           "                    SellLots ", SellLots, NL,
           "                    HighestSell ", HighestSell, NL,
           "                    Buys ", OrdersBUY, NL,
           "                    BuyLots ", BuyLots, NL,
           "                    LowestBuy ", LowestBuy, NL,
           "                    Balance ", AccountBalance(), NL,
           "                    Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
    
// BUY Trade Criteria

    if (Ask<=(Open[0]-(TradeLevel*Point)))   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForBuy();

// SELL Trade Criteria

    if (Bid>=(Open[0]+(TradeLevel*Point)))  
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForSell();

 } // end start()

