 //|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|          Falcon 11 A GBPJPY
//|    Last Updated 1-28-2007 10:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double Lots           = 5;     // how many lots to trade at a time
extern double Weight         = 5;       // each new order increases this amount 
extern int    Orders         = 1;       // number of orders at Lots
extern int    ProfitTarget   = 35;
extern int    SL             = 200;
extern int    CounterEntry   = 5;      // pips above or below open
extern int    EndHour        = 6;
extern int    StartHour      = 15;
extern int    Spacing        = 5;       // min distance above last high or below last low
extern bool   UseAlerts      = true;
extern bool   Boost          = true;    // buy more as the distance outside the band increases
extern bool   IsAcctMini     = true;
extern bool   EndTrading     = false;   // closes EA after all trades close
extern bool   StopTrading    = false;   // Stops All trading but allows trades to close
extern bool   LotIncrease    = false;  

int    Slippage        = 3;             // how many pips of slippage can you tolorate
bool   OneOrderOnly    = false ;        // one order at a time or not
double BoostTrack      = 0;             // used to track compounding and steps

int    MagicNumber     = 325266811427579;       // allows multiple experts to trade on same account
string TradeComment    = "FALCON 11A GBPJPY"; // comment so multiple EAs can be seen in Account History
double StartingBalance = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed    = true;          // used to manage trades
datetime    bartime    = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("sound136.wav");
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for BUY order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double   BuyOrders, SellOrders, LowestBuy=1000, SellLotsHigh;
   int      cnt=0;
   int      gle=0;
   
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
          if (OrderType() == OP_BUY)
            {
             if (OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
             BuyOrders++;
            } 
        }
     }
     
    if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50) Lots=50;
     }
//   if(BuyOrders == 0 && SellOrders >=2) Lots = Lots*SellOrders;
   
   if(TradeAllowed && Ask <= LowestBuy-(Spacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,Lots+((BuyOrders*Weight)/Orders),Ask,Slippage,Ask-SL*Point,0,TradeComment,MagicNumber,Blue);
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+--------------------------------------------------+
//|  Main Start Routine                              |
//+--------------------------------------------------+
int start()
  {
   
   double   TargetLevel, OrdersSELL, OrdersBUY, BuyPips, BuyTarget;
   double   LowestBuy=1000, BuyLots, BuyProfit;
   double   CurrentHour = (TimeHour(CurTime())), LastBuyTime;
   bool     BUYme=false;
   double   Spread = Ask-Bid;
  
   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {
           if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
           if(OrderType()==OP_BUY && OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }
    
    if(CurrentHour >=0 && CurrentHour<5)   TargetLevel = ProfitTarget*1;
    if(CurrentHour >=5 && CurrentHour<17)  TargetLevel = ProfitTarget*0.5;
    if(CurrentHour >=17 && CurrentHour<20) TargetLevel = ProfitTarget*1;
    if(CurrentHour >=20 && CurrentHour<24) TargetLevel = ProfitTarget*1.5;

      BuyTarget  = TargetLevel * BuyLots;   
    
    if(!IsAcctMini)
      {
      BuyTarget  = BuyTarget * 10;
      }

    if(BuyProfit  > BuyTarget && CurTime()-LastBuyTime >=120)  CloseAllThisSymbolBuy(); 

// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<=(Open[0]-(CounterEntry*Point)))   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (CurrentHour >= EndHour && CurrentHour < StartHour && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading && Spread<=14) CheckForBuy();
   
   Comment("                    Falcon 11 A GBPJPY Last Update 1-28-2007 10:00pm", NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyLots        ", BuyLots, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL,
           "                            Margin              ", AccountMargin(), NL,
           "                            MarginPercent        ", MathRound((AccountEquity()/AccountMargin())*100), NL,
           "                            Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));   
 
 } // end start()

