//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|              Falcon 15 
//|   Last Updated 12-6-2006 10:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double Lots           = 0.1;     // how many lots to trade at a time
extern double Weight         = 0.2;     // each new order increases this amount 
extern int    Orders         = 1;       // number of orders at Lots
extern int    ProfitTarget   = 12;
extern int    SL             = 150;
extern int    TrendEntry     = 11;      // pips above or below open
extern int    CounterEntry   = 24;      // pips above or below open
extern int    Spacing        = 10;       // min distance above last high or below last low
extern bool   UseAlerts      = true;
extern bool   Boost          = true;    // buy more as the distance outside the band increases
extern bool   IsAcctMini     = false;
extern bool   EndTrading     = false;   // closes EA after all trades close
extern bool   StopTrading    = false;   // Stops All trading but allows trades to close
extern bool   LotIncrease    = false;  

int    Slippage        = 3;             // how many pips of slippage can you tolorate
bool   OneOrderOnly    = false ;        // one order at a time or not
double BoostTrack      = 0;             // used to track compounding and steps

int    MagicNumber     = 3252668;       // allows multiple experts to trade on same account
string TradeComment    = "FALCON15.txt"; // comment so multiple EAs can be seen in Account History
double StartingBalance = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed    = true;          // used to manage trades
datetime    bartime    = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("CashReg2.wav");
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| Closes all SELL positions                                              |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
        if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
         if (UseAlerts) PlaySound("CashReg2.wav");
     }
  }
  return; 
  }

//+------------------------------------------------------------------+
//| Check for BUY order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double   BuyOrders, LowestBuy=1000;
   int      cnt=0;
   int      gle=0;
   
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
        {
          if (OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
          BuyOrders++;
        }
     }
     
    if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50.0) Lots=50.0;
     }
     
   if (Ask >= LowestBuy-(Spacing*Point)) return;
   if(TradeAllowed && Ask < LowestBuy-(Spacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,Lots+((BuyOrders*Weight)/Orders),Ask,Slippage,Ask-SL*Point,0,TradeComment,MagicNumber,Blue);
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for SELL order conditions                                   |
//+------------------------------------------------------------------+
void CheckForSell()
  {
   double   SellOrders, HighestSell;
   int      cnt=0;
   int      gle=0;
      
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber)
        {
          if (OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
          SellOrders++;
        }
     } 
    
   if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50.0) Lots=50.0;
     }
     
   if(TradeAllowed && Bid > HighestSell+(Spacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_SELL,Lots+((SellOrders*Weight)/Orders),Bid,Slippage,Bid+SL*Point,0,TradeComment,MagicNumber,Orange);
         }
         gle=GetLastError();
         if(gle==0)
           {
           BoostTrack=Close[0];
           TradeAllowed=false;
           }
       }
   }

//+--------------------------------------------------+
//|  Main Start Routine                              |
//+--------------------------------------------------+
int start()
  {
   
   double   TargetLevel, OrdersSELL, OrdersBUY, BuyPips, SellPips, BuyTarget, SellTarget;
   double   HighestSell, LowestBuy=1000, BuyLots, SellLots, BuyProfit, SellProfit;
   double   CurrentTime = (TimeHour(CurTime()+TimeMinute(CurTime())));
   bool     SELLme=false;
   bool     BUYme=false;
  
   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {
           if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
           if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
           if (OrderType() == OP_SELL) SellProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }
    
    if(CurrentTime >=0 && CurrentTime<5)   TargetLevel = ProfitTarget*1;
    if(CurrentTime >=5 && CurrentTime<17)  TargetLevel = ProfitTarget*0.5;
    if(CurrentTime >=17 && CurrentTime<20) TargetLevel = ProfitTarget*1;
    if(CurrentTime >=20 && CurrentTime<24) TargetLevel = ProfitTarget*1.5;

      BuyTarget  = TargetLevel * BuyLots;   
      SellTarget = TargetLevel * SellLots;
    
    if(!IsAcctMini)
      {
      BuyTarget  = BuyTarget * 10;
      SellTarget = SellTarget *10;
      }

    if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
    if(SellProfit > SellTarget) CloseAllThisSymbolSell();
      
   Comment("                    Falcon 15 Last Update 12-6-2006 10:00pm", NL,
           "                    Buys ", OrdersBUY, NL,
           "                    BuyLots           ", BuyLots, NL,
           "                    Sells ", OrdersSELL, NL,
           "                    SellLots           ", SellLots, NL,
           "                    Balance ", AccountBalance(), NL,
           "                    Equity        ", AccountEquity(), NL,
           "                    Margin              ", AccountMargin(), NL,
           "                    Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
    
// Trend Sells  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<=(Open[0]-(TrendEntry*Point)))   
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForSell();
  
// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<=(Open[0]-(CounterEntry*Point)))   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForBuy();
   
// Trend Buys $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Bid>=(Open[0]+(TrendEntry*Point)))  
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForBuy();
    
// Counter SELL Criteria  $$$$$$$$$$$$$$$$$$$$$$$$

    if (Bid>=(Open[0]+(CounterEntry*Point)))  
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForSell();

} // end start()

