//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|             Falcon 18
//|   Last Updated 12-9-2006 10:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double TrendLots           = 2;     // how many lots to trade at a time
extern double TrendWeight         = -0.2;       // each new order increases this amount
extern int    TrendEntry          = 12;      // pips above or below open
extern int    TrendSpacing        = 5;      // min distance above last high or below last low
extern int    TrendSL             = 150;

extern double CounterLots         = 0.2;     // how many lots to trade at a time
extern double CounterWeight       = 0.4;     // each new order increases this amount
extern int    CounterEntry        = 20;      // pips above or below open
extern int    CounterSpacing      = 10;      // min distance above last high or below last low
extern int    CounterSL           = 70;

extern int    Profit              = 10;

extern int    Orders              = 1;       // number of orders at Lots
extern bool   TrendLotIncrease    = true;  
extern bool   CounterLotIncrease  = true;  
extern bool   Boost               = true;    // buy more as the distance outside the band increases
extern bool   IsAcctMini          = true;
extern bool   UseAlerts           = false;
extern bool   EndTrading          = false;   // closes EA after all trades close
extern bool   StopTrading         = false;   // Stops All trading but allows trades to close

int    Slippage                = 3;             // how many pips of slippage can you tolorate
bool   OneOrderOnly            = false ;        // one order at a time or not
double BoostTrack              = 0;             // used to track compounding and steps

int    MagicNumber1            = 32526681;       // allows multiple experts to trade on same account
int    MagicNumber2            = 32526682;       // allows multiple experts to trade on same account
int    MagicNumber3            = 32526683;       // allows multiple experts to trade on same account
int    MagicNumber4            = 32526684;       // allows multiple experts to trade on same account
string TradeComment            = "FALCON18.txt"; // comment so multiple EAs can be seen in Account History
double TrendStartingBalance    = 0;             // lot size control if LotIncrease == true
double CounterStartingBalance  = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed            = true;          // used to manage trades
datetime    bartime            = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(TrendLotIncrease)
     {
      TrendStartingBalance=AccountBalance()/TrendLots;
     }
   
    if(CounterLotIncrease)
     {
      CounterStartingBalance=AccountBalance()/CounterLots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol())  
      {
        if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("CashReg2.wav");
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| Closes all SELL positions                                              
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol())
      {
        if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
         if (UseAlerts) PlaySound("CashReg2.wav");
     }
  }
  return; 
  }

//+------------------------------------------------------------------+
//| Check for Trend BUY order conditions                                
//+------------------------------------------------------------------+
void CheckForTrendBuy()
  {
   double   BuyOrders, LowestBuy=1000, TotalOrders;
   int      cnt=0;
   int      gle=0;
   
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
         {
          if (OrderType() == OP_BUY && OrderOpenPrice()<LowestBuy && OrderMagicNumber()==MagicNumber1)
            {
             LowestBuy=OrderOpenPrice();
             BuyOrders++;
            }
         }
     }
     
    if(TrendLotIncrease)
     {
      TrendLots=NormalizeDouble(AccountBalance()/TrendStartingBalance,2);
      if(TrendLots>100.0) TrendLots=100.0;
     }
     
   if(TradeAllowed && Ask < LowestBuy-(TrendSpacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,TrendLots+((BuyOrders*TrendWeight)/Orders),Ask,Slippage,Ask-TrendSL*Point,0,TradeComment,MagicNumber1,Blue);
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for Trend SELL order conditions                              
//+------------------------------------------------------------------+
void CheckForTrendSell()
  {
   double   SellOrders, HighestSell, TotalOrders;
   int      cnt=0;
   int      gle=0;
      
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol())
        {
          if (OrderType() == OP_SELL  && OrderOpenPrice()>HighestSell && OrderMagicNumber()==MagicNumber2 )
            {
             HighestSell=OrderOpenPrice();
             SellOrders++;
            }
        }
     } 
    
   if(TrendLotIncrease)
     {
      TrendLots=NormalizeDouble(AccountBalance()/TrendStartingBalance,2);
      if(TrendLots>100.0) TrendLots=100.0;
     }
     
   if(TradeAllowed && Bid > HighestSell+(TrendSpacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_SELL,TrendLots+((SellOrders*TrendWeight)/Orders),Bid,Slippage,Bid+TrendSL*Point,0,TradeComment,MagicNumber2,Orange);
         }
         gle=GetLastError();
         if(gle==0)
           {
           BoostTrack=Close[0];
           TradeAllowed=false;
           }
       }
   }

//+------------------------------------------------------------------+
//| Check for Counter BUY order conditions                                
//+------------------------------------------------------------------+
void CheckForCounterBuy()
  {
   double   BuyOrders, LowestBuy=1000, TotalOrders;
   int      cnt=0;
   int      gle=0;
   
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
         {
          if (OrderType() == OP_BUY && OrderOpenPrice()<LowestBuy && OrderMagicNumber()==MagicNumber3)
            {
             LowestBuy=OrderOpenPrice();
             BuyOrders++;
            }
         }
     }
     
    if(CounterLotIncrease)
     {
      CounterLots=NormalizeDouble(AccountBalance()/CounterStartingBalance,2);
      if(CounterLots>100.0) CounterLots=100.0;
     }
     
   if(TradeAllowed && Ask < LowestBuy-(CounterSpacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,CounterLots+((BuyOrders*CounterWeight)/Orders),Ask,Slippage,Ask-CounterSL*Point,0,TradeComment,MagicNumber3,Blue);
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for Counter SELL order conditions                                  
//+------------------------------------------------------------------+
void CheckForCounterSell()
  {
   double   SellOrders, HighestSell, TotalOrders;
   int      cnt=0;
   int      gle=0;
      
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol())
        {
          if (OrderType() == OP_SELL && OrderOpenPrice()>HighestSell && OrderMagicNumber()==MagicNumber4)
            {
             HighestSell=OrderOpenPrice();
             SellOrders++;
            }
        }
     } 
    
   if(CounterLotIncrease)
     {
      CounterLots=NormalizeDouble(AccountBalance()/CounterStartingBalance,2);
      if(CounterLots>100.0) CounterLots=100.0;
     }
     
   if(TradeAllowed && Bid > HighestSell+(CounterSpacing*Point))
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_SELL,CounterLots+((SellOrders*CounterWeight)/Orders),Bid,Slippage,Bid+CounterSL*Point,0,TradeComment,MagicNumber4,Orange);
         }
         gle=GetLastError();
         if(gle==0)
           {
           BoostTrack=Close[0];
           TradeAllowed=false;
           }
       }
   }

//+--------------------------------------------------+
//|  Main Start Routine                              
//+--------------------------------------------------+
int start()
  {
   
   double   TargetLevel, OrdersSELL, OrdersBUY, BuyPips, SellPips, BuyTarget, SellTarget;
   double   HighestSell, LowestBuy=1000, BuyLots, SellLots, BuyProfit, SellProfit;
   double   TotalTarget, TotalProfit, TotalLots, ProfitTarget, OverallProfit;
   double   BuyProfitTarget, SellProfitTarget, TotalProfitTarget, OverallTarget, LargestMargin;
   double   CurrentTime = (TimeHour(CurTime()+TimeMinute(CurTime())));
   bool     SELLme=false;
   bool     BUYme=false;
  
   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol())
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
           if (OrderType() == OP_SELL) SellProfit += OrderProfit() + OrderCommission() + OrderSwap();
           TotalProfit+=OrderProfit();
           TotalLots+=OrderLots();
        }
     }
    
    if(CurrentTime >=0 && CurrentTime<5)   ProfitTarget = Profit*1;
    if(CurrentTime >=5 && CurrentTime<17)  ProfitTarget = Profit*0.5;
    if(CurrentTime >=17 && CurrentTime<20) ProfitTarget = Profit*1;
    if(CurrentTime >=20 && CurrentTime<24) ProfitTarget = Profit*1.5;

    BuyTarget   = ProfitTarget * BuyLots + OrdersSELL*10;   
    SellTarget  = ProfitTarget * SellLots + OrdersBUY*10;
      
    if(!IsAcctMini)
      {
      BuyTarget  = BuyTarget * 10;
      SellTarget = SellTarget *10;
      }
    
    if(BuyTarget  < 5) BuyTarget = 5;
    if(SellTarget < 5) SellTarget = 5;
    
    if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
    if(SellProfit > SellTarget) CloseAllThisSymbolSell();

   Comment("                    Falcon 18 Last Update 12-9-2006 10:00pm", NL,
           "                    Buys ", OrdersBUY, NL,
           "                    BuyLots           ", BuyLots, NL,
           "                    Sells ", OrdersSELL, NL,
           "                    SellLots           ", SellLots, NL,
           "                    Balance ", AccountBalance(), NL,
           "                    Equity        ", AccountEquity(), NL,
           "                    Margin              ", AccountMargin(), NL,
           "                    Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
    
// Trend Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 
    if (Bid>=(Open[0]+(TrendEntry*Point)))  
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForTrendBuy();

// Trend Sells $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

       if (Ask<=(Open[0]-(TrendEntry*Point)))   
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForTrendSell();
      
// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<=(Open[0]-(CounterEntry*Point)))   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForCounterBuy();
   
// Counter SELL Criteria  $$$$$$$$$$$$$$$$$$$$$$$$

    if (Bid>=(Open[0]+(CounterEntry*Point)))  
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForCounterSell();

} // end start()

