//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|               Falcon5 
//|   Last Updated 10-26-2006 10:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL    "\n" 
#include <stdlib.mqh>

extern double Lots           =  0.1;    // how many lots to trade at a time
extern double Weight         =  0.2;
extern double MaxLots        =  1.25;
extern double ProfitPips     =  15;
extern double TargetLevel    =  5;       // 1 = Low Risk 2 = Medium Risk, 3 = High Risk
extern double TradeLevel     =  5;
extern int    Spacing        =  5;       // min distance above last high or below last low
extern int    RevTimeHour1   =  6;
extern int    RevTimeMinute1 =  0;
extern int    RevDuration1   =  60;
extern int    RevTimeHour2   =  13;
extern int    RevTimeMinute2 =  30;
extern int    RevDuration2   =  270;
extern int    MaxMargin      =  4000;
extern bool   PlayAlert      =  true;
extern bool   LotIncrease    =  true;  
extern bool   Boost          =  true;    // buy more as the distance outside the band increases
extern bool   UseHedge       =  true;
extern bool   EndTrading     =  false;   // closes EA after all trades close
extern double EndHour        =  14;      // stop trading after this time friday

int    EndDay       =    365;
int    Slippage     =    0;        // how many pips of slippage can you tolorate
bool   OneOrderOnly =    false ;   // one order at a time or not
int    LPeriod      =       1;     // Level period
int    Deviation    =       1;     // Level deviation
double BoostTrack;                 // used to track compounding and steps

int    MagicNumber  =   32526664642;        // allows multiple experts to trade on same account
string TradeComment = "_FALCON mini2.txt";  // comment so multiple EAs can be seen in Account History
double StartingBalance = 0;                 // lot size control if LotIncrease == true
bool   TradeAllowed=true;                // used to manage trades

// Min/Max tracking and tick logging
int    maxOrders;                        // statistic for maximum numbers or orders open at one time
double maxEquity;                        // statistic for maximum equity level
double minEquity;                        // statistic for minimum equity level
double maxOEquity;                       // statistic for maximum equity level per order
double minOEquity;                       // statistic for minimum equity level per order 
double EquityPos=0;                      // statistic for number of ticks order was positive
double EquityNeg=0;                      // statistic for number of ticks order was negative
double EquityZer=0;                      // statistic for number of ticks order was zero

//+-------------+
//| Custom init |
//|-------------+

int init()
  {
   if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+

int deinit()
  {

  }
  
//+---------------------------------------------------+
//| Closes all Buys this symbol only                  |
//+---------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
 
     for(int i=totalorders-1;i>=0;i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  
         {
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
     
  return; 
}
   
//+-----------------------------------------------------+
//| Closes all Sells this symbol only                   |
//+-----------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
 
     for(int i=totalorders-1;i>=0;i--)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
       {
         if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
 
  return; 
}

//+----------------------------------------------+
//| cancels all Buys in Profit                   |
//+----------------------------------------------+
void CloseSymbolBuysinProfit()
{
  int OrdersBUY, BuyProfit;
  int totalorders = OrdersTotal();
 
     for(int i=totalorders-1;i>=0;i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  // only look if mygrid and symbol...
         {
           if ( OrderType() == OP_BUY ) BuyProfit = OrderProfit() + OrderSwap() + OrderCommission();
             {
              if ( OrderType() == OP_BUY && BuyProfit > 0)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
             }
         }
       }
     
  return; 
}
   
//+-----------------------------------------------+
//| cancels all Sells in Profit                   |
//+-----------------------------------------------+
void CloseSymbolSellsinProfit()
{
  int OrdersSELL, SellProfit;
  int totalorders = OrdersTotal();
 
    for(int i=totalorders-1;i>=0;i--)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  // only look if mygrid and symbol...
       {
        if ( OrderType() == OP_SELL ) SellProfit = OrderProfit() + OrderSwap() + OrderCommission();
          {
          if ( OrderType() == OP_SELL  && SellProfit > 0)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
          }
       }
     }
 
  return; 
}
    
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, LowestBuy, HighestSell;
  double  TotalProfit, BuyProfit, SellProfit, BuyTarget, SellTarget;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {
         if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit() + OrderSwap() + OrderCommission();
         if (OrderType() == OP_SELL) SellProfit +=  OrderProfit() + OrderSwap() + OrderCommission();
         if (OrderType() == OP_BUY)  BuyOrders++;
         if (OrderType() == OP_SELL) SellOrders++;
         if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
         if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
        }
     }
    
     if(PlayAlert && BuyOrders > 0 && Bid > LowestBuy + ProfitPips*Point || SellOrders >0 && Ask < HighestSell - ProfitPips*Point)
        {
         PlaySound("alert.wav");
        }  
     
    BuyTarget  = Lots * TargetLevel * BuyOrders;   
    SellTarget = Lots * TargetLevel * SellOrders;

    if(Bid > LowestBuy + ProfitPips*Point) CloseSymbolBuysinProfit(); 
    if(Ask < HighestSell - ProfitPips*Point) CloseSymbolSellsinProfit();

    if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
    if(SellProfit > SellTarget) CloseAllThisSymbolSell();
    return;
  }
//+------------------------------------------------------------------+
//| Check for BUY order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy ()
  {
   double   i, BuyPips, BuyLots, LowestBuy;
   int      OrdersBUY;
   int      OrdersPerSymbol;
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   double   SL=0;
   double   TP=0;
      
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
         if(OrderType()==OP_BUY) OrdersBUY++;
         if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
        }
     } 
   
   // Lot increasement based on AccountBalance when expert is started
   // this will trade 1.0, then 1.1, then 1.2 etc as account balance grows
   // or 0.9 then 0.8 then 0.7 as account balance shrinks 
   if(LotIncrease)
     {
      BuyLots=NormalizeDouble(AccountBalance()/StartingBalance,2);
     } 
   
   if(OrdersBUY > 1) Lots = NormalizeDouble(BuyLots + (BuyLots * (OrdersBUY * Weight)),2);
   if(Lots>MaxLots) Lots=MaxLots;
   
   if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
    //ENTRY LONG (buy, Ask)
   if( TradeAllowed )
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,TradeComment,MagicNumber,Blue);
         Sleep (2000);
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
            break;
           }
        }//while
     }//BUYme
   }

//+------------------------------------------------------------------+
//| Check for Hedge order conditions                                 |
//+------------------------------------------------------------------+
void CheckForHedge()
  {
   double   i, BuyPips, BuyLots, SellPips, SellLots, LowestBuy, HighestSell;
   int      OrdersBUY, OrdersSELL;
   int      OrdersPerSymbol;
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   double   SL=0;
   double   TP=0;
      
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
         if(OrderType()==OP_BUY) OrdersBUY++; 
         if(OrderType()==OP_SELL) OrdersSELL++;
         if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
         if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
        }
     } 
   
   if(LotIncrease)
     {
      BuyLots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      SellLots=NormalizeDouble(AccountBalance()/StartingBalance,2);
     } 
   
   if(OrdersBUY > 1) Lots = NormalizeDouble(BuyLots + (BuyLots * (OrdersBUY * Weight)),2);
   if(OrdersSELL > 1) Lots = NormalizeDouble(SellLots + (SellLots * (OrdersSELL * Weight)),2);
   if(Lots>MaxLots) Lots=MaxLots;
   
   if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
    //ENTRY LONG (buy, Ask)
   if( TradeAllowed )
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,TradeComment,MagicNumber,Blue);
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,TradeComment,MagicNumber,Red);
         Sleep (2000);
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
            break;
           }
        }//while
     }//BUYme
   }
    
//+------------------------------------------------------------------+
//| Check for SELL order conditions                                   |
//+------------------------------------------------------------------+
void CheckForSell ()
  {
   double   i, SellPips, SellLots, HighestSell;
   int      OrdersSELL;
   int      OrdersPerSymbol;
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   double   SL=0;
   double   TP=0;
      
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
         if(OrderType()==OP_SELL) OrdersSELL++;
         if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();

        }
     } 
   
   if(LotIncrease)
     {
      SellLots=NormalizeDouble(AccountBalance()/StartingBalance,2);
     } 
   
   if(OrdersSELL > 1) Lots = NormalizeDouble(SellLots + (SellLots * (OrdersSELL * Weight)),2);
   if(Lots>MaxLots) Lots=MaxLots;
   
   if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   //ENTRY SHORT (sell, Bid)
   if( TradeAllowed && Ask > (HighestSell + (Spacing+2)*Point))
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,TradeComment,MagicNumber,Red);
         Sleep (2000);
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
            break;
           }
        }//while
     }//SELLme
   }
    
//+-----------+
//| Main      |
//+-----------+
int start()
  {
  
   CheckForClose();
   
   if(AccountMargin() > MaxMargin) return;
   
   // Is the EA still valid?
   if (DayOfYear() >= EndDay) 
      {
         Alert("EA has expired...");
         return;
      }
   
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   int      OrdersPerSymbol=0;
   int      OrdersBUY=0;
   int      OrdersSELL=0;
  
   // stoploss and takeprofit and close control
   double LowestBuy = 1000;
   double HighestSell;
   double CurrentHour = (TimeHour(CurTime()));
   double CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);       
   double RevTime1 = (RevTimeHour1*3600+RevTimeMinute1*60);
   double RevTime2 = (RevTimeHour2*3600+RevTimeMinute2*60);

   // direction control
   bool BUYme=false;
   bool SELLme=false;
   bool HEDGEme=false;   
   OrdersPerSymbol=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
        }
     }
    
  

//+------------------------------------------------------------------+
//  Determine last order price                                       |
//-------------------------------------------------------------------+
      for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
           {
           if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
           if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
           OrdersPerSymbol++;
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           }
      }               
   
    if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   Comment("                 Sells ", OrdersSELL,NL,
           "                 Buys ", OrdersBUY,NL,
           "                 HighestSell ", HighestSell,NL,
           "                 LowestBuy ", LowestBuy, NL,
           "Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
        
   double bup=iBands(Symbol(),0,LPeriod,Deviation,0,PRICE_OPEN,MODE_UPPER,0);
   double bdn=iBands(Symbol(),0,LPeriod,Deviation,0,PRICE_OPEN,MODE_LOWER,0);
   
     if(Close[0]>bup+(TradeLevel*Point) && Ask > HighestSell + (Spacing+2)*Point) 
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     }
     
     if(CurrentTime > RevTime1 && CurrentTime < RevTime1 + RevDuration1*60 || CurrentTime > RevTime2 && CurrentTime < RevTime2 + RevDuration2*60 && Ask > HighestSell + (Spacing+2)*Point) 
       {
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         HEDGEme=true; 
         TradeAllowed=true;
        }
     }
     
     if(Close[0]<bdn-(TradeLevel*Point) && Ask < LowestBuy - Spacing*Point) 
      {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    
    if(CurrentTime > RevTime1 && CurrentTime < RevTime1 + RevDuration1*60 || CurrentTime > RevTime2 && CurrentTime < RevTime2 + RevDuration2*60 && Close[0]<bdn-(TradeLevel*Point) && Ask < LowestBuy - Spacing*Point) 
      {
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         HEDGEme=true;
         TradeAllowed=true;
         }
      }      
     
   if (EndTrading == true && OrdersSELL == 0) SELLme = false;
   if (DayOfWeek()>=5 && CurrentHour >= EndHour && OrdersSELL == 0) SELLme =false; 

   if (EndTrading == true && OrdersBUY == 0) BUYme = false;
   if (DayOfWeek()>=5 && CurrentHour >= EndHour && OrdersBUY == 0) BUYme =false; 
  
   if (BUYme == true)  CheckForBuy();

   if (SELLme == true) CheckForSell();
     
   if (UseHedge && HEDGEme == true) CheckForHedge();
   
   return(0);
    
 } // start()

 




