//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|            Falcon Pedro 2
//|     Last Updated 1-8-2007 3:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern int    StartHour1          = 0;
extern int    EndHour1            = 8;
extern int    CounterEntry1       = 30;      // pips above or below open

extern int    StartHour2          = 12;
extern int    EndHour2            = 16;
extern int    CounterEntry2       = 44;      // pips above or below open

extern double CounterLots         = 5;       // how many lots to trade at a time
extern double Weight              = 5;
extern int    CounterSL           = 40;
extern bool   CounterBoost        = true;    // buy more as the distance outside the band increases
extern int    Spacing             = 3;
extern bool   CounterLotIncrease  = true;  

extern int    Profit              = 18;
extern int    MaxTrades           = 4;
extern int    Orders              = 1;       // number of orders at Lots

extern bool   IsAcctMini          = true;
extern bool   UseAlerts           = true;
extern bool   EndTrading          = false;   // closes EA after all trades close
extern bool   StopTrading         = false;   // Stops All trading but allows trades to close

int    Slippage                = 3;             // how many pips of slippage can you tolorate
bool   OneOrderOnly            = false ;        // one order at a time or not
double BoostTrack              = 0;             // used to track compounding and steps

int    MagicNumber             = 25266872;       // allows multiple experts to trade on same account
string TradeComment            = "FALCONPedro2.txt"; // comment so multiple EAs can be seen in Account History
double CounterStartingBalance  = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed            = true;          // used to manage trades
datetime    bartime            = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(CounterLotIncrease)
     {
      CounterStartingBalance=AccountBalance()/CounterLots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if (OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("yodel.wav");
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| Closes all SELL positions                                              
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
        if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
         if (UseAlerts) PlaySound("CashReg2.wav");
     }
  }
  return; 
  }

/*//+------------------------------------------------------------------------+
//| Modifies all positions                                              
//+------------------------------------------------------------------------+
void CheckForTrailingStop()
{
     for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
           if(OrderSymbol()==Symbol() && OrderType()==OP_BUY){
               if(High[0]-OrderStopLoss()>=(CounterSL+TrailingStop)*Point){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()+TrailingStop*Point,OrderTakeProfit(),0,Green);
               }   
            }   
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL){
               if(OrderStopLoss()-Low[0]>=(CounterSL+TrailingStop)*Point){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-TrailingStop*Point,OrderTakeProfit(),0,Green);
               }
            }
         }
  return; 
  }
 */ 
//+------------------------------------------------------------------+
//| Check for Counter BUY order conditions                                
//+------------------------------------------------------------------+
void CheckForCounterBuy()
  {
   double   BuyOrders, LowestBuy=1000;
   int      cnt=0;
   int      gle=0;

   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
         {
          if (OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
            {
              BuyOrders++;
              if(OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
            }
         }
     }
     
    if(CounterLotIncrease)
     {
      CounterLots=NormalizeDouble(AccountBalance()/CounterStartingBalance,2);
      if(CounterLots>50 && IsAcctMini) CounterLots=50;
      if(CounterLots>100 && !IsAcctMini) CounterLots=100;
    }
     
   if(TradeAllowed && Ask <= LowestBuy-Spacing*Point)
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,CounterLots+((BuyOrders*Weight)/Orders),Ask,Slippage,Ask-CounterSL*Point,0,TradeComment,MagicNumber,Blue);
         }
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for Counter SELL order conditions                                  
//+------------------------------------------------------------------+
void CheckForCounterSell()
  {
   double   SellOrders, HighestSell;
   int      cnt=0;
   int      gle=0;
      
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol())
        {
          if (OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber)
            {
              SellOrders++;
              if(OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
            }
        }
     } 
    
   if(CounterLotIncrease)
     {
      CounterLots=NormalizeDouble(AccountBalance()/CounterStartingBalance,2);
      if(CounterLots>50 && IsAcctMini) CounterLots=50;
      if(CounterLots>100 && !IsAcctMini) CounterLots=100;
     }
     

   if(TradeAllowed && Bid >= HighestSell+Spacing*Point)
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_SELL,CounterLots+((SellOrders*Weight)/Orders),Bid,Slippage,Bid+CounterSL*Point,0,TradeComment,MagicNumber,Orange);
         }
         gle=GetLastError();
         if(gle==0)
           {
           BoostTrack=Close[0];
           TradeAllowed=false;
           }
       }
   }

//+--------------------------------------------------+
//|  Main Start Routine                              
//+--------------------------------------------------+
int start()
  {
   
   double   OrdersSELL, OrdersBUY, BuyTarget, SellTarget, CounterEntry;
   double   BuyLots, SellLots, BuyProfit, SellProfit, ProfitTarget, LargestMargin;
   int      CurrentTime = TimeHour(CurTime());
   bool     SELLme=false;
   bool     BUYme=false;
   double   Stoch1 = iStochastic(NULL,60,100,22,1,MODE_LWMA,0,MODE_SIGNAL,0);
   double   Stoch2 = iStochastic(NULL,60,100,22,1,MODE_LWMA,0,MODE_SIGNAL,1);
   double   Spread = Ask-Bid;
   
   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
           if (OrderType() == OP_SELL) SellProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }
    
    if(CurrentTime >=0 && CurrentTime<5)   ProfitTarget = Profit*1;
    if(CurrentTime >=5 && CurrentTime<17)  ProfitTarget = Profit*0.5;
    if(CurrentTime >=17 && CurrentTime<20) ProfitTarget = Profit*1;
    if(CurrentTime >=20 && CurrentTime<24) ProfitTarget = Profit*1.5;

    BuyTarget   = ProfitTarget * BuyLots + OrdersSELL*10;   
    SellTarget  = ProfitTarget * SellLots + OrdersBUY*10;
    
    if(!IsAcctMini)
      {
      BuyTarget  = BuyTarget  * 10;
      SellTarget = SellTarget * 10;
      }
    
    if(BuyTarget  < 5) BuyTarget  = 5;
    if(SellTarget < 5) SellTarget = 5;
  
    if(Stoch1 > Stoch2) BuyTarget  = BuyTarget *1.5;
    if(Stoch2 > Stoch1) SellTarget = SellTarget*1.5;
 
    if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
    if(SellProfit > SellTarget) CloseAllThisSymbolSell();

 if(OrdersBUY + OrdersSELL < MaxTrades && CurrentTime >=StartHour1 && CurrentTime<EndHour1 || CurrentTime>=StartHour2 && CurrentTime<EndHour2)  
    {
 
 if(CurrentTime >=StartHour1 && CurrentTime<EndHour1) CounterEntry = CounterEntry1;
 if(CurrentTime >=StartHour2 && CurrentTime<EndHour2 && DayOfWeek()!=5) CounterEntry = CounterEntry2;
 if(CurrentTime >=StartHour2 && CurrentTime<EndHour2 && DayOfWeek()==5) CounterEntry = CounterEntry2*1.5;
 if(CurrentTime >=StartHour2 && CurrentTime<EndHour2 && DayOfWeek()==5 && Day()<8) CounterEntry = CounterEntry2*2;
 
// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<=(Open[0]-(CounterEntry*Point)) && Spread<=4)   
       {
       BUYme=true;  
       if(CounterBoost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForCounterBuy();
   
// Counter SELL Criteria  $$$$$$$$$$$$$$$$$$$$$$$$

    if (Bid>=(Open[0]+(CounterEntry*Point)) && Spread<=4)  
       {
       SELLme=true; 
       if(CounterBoost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForCounterSell();
  }
 
   Comment("                    Falcon Pedro 2 Last Update 1-8-2007 3:00pm", NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyLots        ", BuyLots, NL,
           "                            Sells    ", OrdersSELL, NL,
           "                            SellLots        ", SellLots, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL,
           "                            Margin              ", AccountMargin(), NL,
           "                            MarginPercent        ", MathRound((AccountEquity()/AccountMargin())*100), NL,
           "                            Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));   

} // end start()

