//+------------------------------------------------------------------+
//| Copyright 2006, Open Source                                      |
//| http://www.finanzaonline.com                                     |
//+------------------------------------------------------------------+

#property copyright "Copyright 2006, Open Source"
#property link      " "
#include <stdlib.mqh>
#define MAGIC 943448

extern double Lots          = 0.1;
extern int    Timeframe     = 240;
extern int    BuyRSI        = 10;
extern int    SellRSI       = 90;
extern double lStopLoss     = 2000;
extern double sStopLoss     = 2000;
extern double lTakeProfit   = 2000;
extern double sTakeProfit   = 2000;
extern double TargetLevel   = 30;       
extern int    Slippage      = 1;
extern int    startbuy      =  10;     // allows trading when longstoch gets below this level
extern int    startsell     =  90;     // allows trading when longstoch gets above this level
extern int    StochK        =  60;     // stochastic setting on "longterm" time frame
extern int    StochD        =  4;     // stochastic setting on "longterm" time frame
extern int    StochSlowing  =  10;     // stochastic setting on "longterm" time frame
extern bool   LotIncrease   = true;  
extern bool   IsAcctMini    = true;
extern bool   UseSound      = True;

color  clOpenBuy     = Blue;
color  clCloseBuy    = Aqua;
color  clOpenSell    = Red;
color  clCloseSell   = Violet;
color  clModiBuy     = Blue;
color  clModiSell    = Red;
string Name_Expert   = "Magic RSI";
string NameFileSound = "alert.wav";

double StartingBalance = 0;                 
bool   TradeAllowed    = true;   

extern bool   OneEntryPerBar    = true;

datetime
         CheckTime,
         CheckEntryTime,
         CrossTime;
         
static int TimeFrame            = 0;           

//+-------------+
//| Custom init |
//|-------------+

int init()
  {
   if(LotIncrease)
     {
      StartingBalance = AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+

int deinit()
  {
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
  }

//+---------------------------------------------------+
//| Closes all Buys this symbol only                  |
//+---------------------------------------------------+
void CloseAllThisSymbolBuy()
{
 
   for(int i = 0; i < OrdersTotal(); i++)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)  
         {
           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
     
  return; 
}
   
//+-----------------------------------------------------+
//| Closes all Sells this symbol only                   |
//+-----------------------------------------------------+
void CloseAllThisSymbolSell()
{

   for(int i = 0; i < OrdersTotal(); i++)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC) 
       {
         if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
 
  return; 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   
   double BuyLots, SellLots, BuyProfit, SellProfit, BuyTarget, SellTarget;
   double OrdersBUY, OrdersSELL;
   int    OrdersPerSymbol;
  
   if(OneEntryPerBar)
    {
     if(CheckEntryTime==iTime(NULL,TimeFrame,0)) return(0); else CheckEntryTime = iTime(NULL,TimeFrame,0);
    }  
   for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
           {
           OrdersPerSymbol++;
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit() + OrderSwap() + OrderCommission();
           if (OrderType() == OP_SELL) SellProfit +=  OrderProfit() + OrderSwap() + OrderCommission();
           }
      }
      
      BuyTarget  = Lots * TargetLevel;   
      SellTarget = Lots * TargetLevel;
   if(!IsAcctMini)
      {
      BuyTarget = BuyTarget * 10;
      SellTarget = SellTarget * 10;
      }
                      
   if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
   if(SellProfit > SellTarget) CloseAllThisSymbolSell();
    
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   if(lTakeProfit<10){
      Print("TakeProfit less than 10");
      return(0);
   }
   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   if(sTakeProfit<10){
      Print("TakeProfit less than 10");
      return(0);
   }

   double diRSI0=iRSI(NULL,Timeframe,3,PRICE_CLOSE,0);
   double diRSI1=iRSI(NULL,Timeframe,3,PRICE_CLOSE,0);
   double currentstoch  = iStochastic(NULL,Timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   double previousstoch = iStochastic(NULL,Timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);

   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   
    if(OrdersPerSymbol==0) TradeAllowed=true;

      if ((diRSI0<BuyRSI) && TradeAllowed){   
         OpenBuy();
         return(0);
      }

      if ((diRSI1>SellRSI) && TradeAllowed){  
         OpenSell();
         return(0);
      }
   
   return (0);
}

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
    if(LotIncrease)
     {
      ldLot=NormalizeDouble(AccountBalance()/StartingBalance,2);
     }
   if(ldLot>100) ldLot = 100;  
   ldStop = GetStopLossBuy(); 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
    if(LotIncrease)
     {
      ldLot=NormalizeDouble(AccountBalance()/StartingBalance,2);
     }
   if(ldLot>100) ldLot = 100;  
   ldStop = GetStopLossSell(); 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { 	return(Name_Expert); } 
double GetSizeLot()         { 	return(Lots); } 
double GetStopLossBuy()     { 	return (Bid-lStopLoss*Point);} 
double GetStopLossSell()    { 	return(Ask+sStopLoss*Point); } 
double GetTakeProfitBuy()   { 	return(Ask+lTakeProfit*Point); } 
double GetTakeProfitSell()  { 	return(Bid-sTakeProfit*Point); } 

