
//The MoneyMaker by Nicolas Engleman

extern string General_Settings = "---------- General Settings";
extern int fastma=44;
extern int slowma=79;
extern int currency_momentum=43;
extern int trend_momentum=28;
extern int maxpipfromEMA=26;
extern int trending=14;
extern double risk_percent=0.20;
extern string Stop_Settings = "---------- Stop Settings";
extern bool use_stop=true;
extern double buy_maxhoursNeg=53;
extern double buy_maxpipsNeg=68;
extern double sell_maxhoursNeg=68;
extern double sell_maxpipsNeg=87;
extern string Spike_Settings = "---------- Spike Settings";
extern bool use_spike=true;
extern int SpikeHeight=71;
extern int PreSpikeGap=109;

string trend,buy,sell;

int start()
  {
  double lot,fastt,sloww,currency_momentumA,currency_momentumB,currency_momentumC,currency_momentumD,trend_momentumFastA,
         trend_momentumFastB,trend_momentumFastC,trend_momentumFastD,average,width,averagepips,opentime,stopip,trend_momentumSlowA,
         trend_momentumSlowB,stopaverage;
  int total,ticket,ope,i,cnt,open,block,big,can,spike;
  
//*********************1-Hour definitions***********************************
  average=iMA(NULL,PERIOD_H1,3,0,MODE_EMA,PRICE_CLOSE,1);
  stopaverage=iMA(NULL,PERIOD_H1,3,0,MODE_EMA,PRICE_CLOSE,1);
  fastt=iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,1);
  sloww=iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,1);
  currency_momentumA=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,currency_momentum,1,currency_momentum,0,1);
  currency_momentumB=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,currency_momentum,1,currency_momentum,1,1);
  currency_momentumC=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,currency_momentum,1,currency_momentum,0,3);
  trend_momentumFastA=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,0,1);
  trend_momentumFastB=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,0,2);
  trend_momentumFastC=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,0,3);
  trend_momentumFastD=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,1,1);
  trend_momentumSlowA=iCustom(NULL,PERIOD_H1,"OSMAMA",6,8,slowma*3,currency_momentum*3,currency_momentum*3,0,1);
  trend_momentumSlowB=iCustom(NULL,PERIOD_H1,"OSMAMA",6,8,slowma*3,currency_momentum*3,currency_momentum*3,0,5);
 //**************************************************************************
  
//***********Misc. Definitions***************************************************
  lot=AccountBalance()*0.02*risk_percent;
  total=OrdersTotal();
  width=MathAbs(fastt-sloww);
//*******************************************************************************

//*************Checks for any Open Trades***********
  for(i=0;i<total;i++)
         {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            {
            if(OrderSymbol()==Symbol())
               {
              open++;
               }
            }
         }
 //************************************************
 
 //***********************Spike Detector**************************************
  if(use_spike==true)
     {
      if(MathAbs(Close[1]-Open[3])>SpikeHeight*Point) 
         {
          if(fastma>slowma)
               {
               if(trend_momentumFastB<0)
                  {
                  spike++;
                  } 
               }
           if(fastma<slowma)
               {
               if(trend_momentumFastB>0)
                  {
                  spike++;
                  } 
              }
          }
      }
//***************************************************************************
 
//*********************To Open Trades**************************************
     
     if(open<1)
         {
        if((Open[2]<fastt) && (Close[1]>sloww) && (spike<1) && (fastt<sloww) && (currency_momentumA>0) && ((currency_momentumC<0) || 
        (trend_momentumSlowA>trend_momentumSlowB)) && ((MathAbs(Ask-sloww)<width*2) || ((MathAbs(Ask-sloww))<maxpipfromEMA*Point)) && 
         (MathAbs(trend_momentumSlowA)>trending*Point))
            {
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,10,0,0,0,1,0,Green);
            PlaySound("alert.wav");
            trend="buy";
            return(0);
            }
         if((trend=="buy") && (trend_momentumFastA>0) && (trend_momentumFastC<0) && (average>fastt) && (fastt>sloww)
            && ((MathAbs(Ask-fastt))<maxpipfromEMA*Point) && (trend_momentumSlowA>trend_momentumSlowB) && (fastt>sloww))
            {
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,10,0,0,0,1,0,Green);
            PlaySound("alert.wav");
            return(0);
            }
        if((Open[2]>fastt) && (Close[1]<sloww) && (fastt>sloww) && (spike<1) && (currency_momentumA<0) && ((currency_momentumC>0) ||
            (trend_momentumSlowA<trend_momentumSlowB)) && ((MathAbs(sloww-Bid)<width*2) || ((MathAbs(sloww-Bid))<maxpipfromEMA*Point)) &&
            (MathAbs(trend_momentumSlowA)>trending*Point)) 
            {
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,10,0,0,0,1,0,Green);
            PlaySound("alert.wav");
            trend="sell";
            return(0);
            }
         if((trend=="sell") && (trend_momentumFastA<0) && (trend_momentumFastC>0) && (average<fastt) && (fastt<sloww)
            && ((MathAbs(fastt-Bid))<maxpipfromEMA*Point) && (trend_momentumSlowA<trend_momentumSlowB) && (fastt<sloww)) 
            {
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,10,0,0,0,1,0,Green);
            PlaySound("alert.wav");
            return(0);
            }
         }
       
//***************************************************************************

//***********************Sets Stop, Protects from Loss***********************
if(use_stop==true)
      {
  for(i=0;i<total;i++)
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
          {
          if(OrderType()==OP_BUY && (stopaverage<OrderOpenPrice()))
                   {
                   averagepips=(MathAbs(OrderOpenPrice()-stopaverage))*10000.0;
                   opentime=(TimeCurrent()-OrderOpenTime())/3600.0;
                   stopip=(opentime/(buy_maxhoursNeg))*(opentime*(buy_maxpipsNeg/(buy_maxhoursNeg)))-buy_maxpipsNeg;
                   if(stopip<0)
                        {
                        if(MathAbs(averagepips/(stopip/opentime))>opentime)
                           {
                           can++;
                           }
                        }
                   if(stopip>0)
                        {
                        can++;
                        }
                     }
         if(OrderType()==OP_SELL && (stopaverage>OrderOpenPrice()))
                   {
                     averagepips=(MathAbs(stopaverage-OrderOpenPrice()))*10000.0;
                     opentime=(TimeCurrent()-OrderOpenTime())/3600.0;
                     stopip=((-opentime/(sell_maxhoursNeg))*(opentime*(sell_maxpipsNeg/(sell_maxhoursNeg)))+sell_maxpipsNeg);
                     if(stopip>0)
                           {
                           if((averagepips/(stopip/opentime))>opentime)
                              {
                              can++;
                              }
                           }
                     if(stopip<0)
                           {
                           can++;
                           }
                        }
                     } 
                  } 
               }
 //***************************************************************************     

//******************To Close Trades******************************************               
   for(cnt=0;cnt<total;cnt++)
         {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            {
            if(OrderType()==OP_BUY) 
               {
                if((currency_momentumA<0) && (currency_momentumA<currency_momentumB) && (average<fastt) && 
                  (trend_momentumFastA<trend_momentumFastD) && (spike<1)) 
                     {
                     OrderClose(OrderTicket(),OrderLots(),Bid,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
               if((can>0) && (spike<1)) 
                     {
                     OrderClose(OrderTicket(),OrderLots(),Bid,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
               }
              if(OrderType()==OP_SELL) 
                 {
                 if((currency_momentumA>0) && (currency_momentumA>currency_momentumB) && (average>fastt) && 
                    (trend_momentumFastA>trend_momentumFastD) && (spike<1))
                     {
                     OrderClose(OrderTicket(),OrderLots(),Ask,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
                 if((can>0) && (spike<1))
                     {
                     OrderClose(OrderTicket(),OrderLots(),Ask,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
                 
                  }
               }
            }
//*****************************************************************************
}
      