//+------------------------------------------------------------------+
//|                                                  NewsBreakv8.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                  August 19, 2006 |
//+------------------------------------------------------------------+
#define MAGIC1  20060819
#define MAGIC2  12345678
#define MAGIC3  01221962
#define MAGIC4  07221958

#include <stdlib.mqh>
#define     NL    "\n"

extern int     RiskPercent    = 100;
 
extern bool    wantNews1      = true;
extern int     NewsHour1      = 12;
extern int     NewsMinutes1   = 31;

extern bool    wantNews2      = true;
extern int     NewsHour2      = 12;
extern int     NewsMinutes2   = 31;

extern bool    wantOCO        = false;
extern int     PendingTime    = 120;
extern double  NewsLots       = 5;
extern int     NewsPips       = 5;
extern int     NewsTP         = 85;
extern int     NewsSL         = 60;
extern int     NewsLookBack   = 1;
extern int     BEpips         = 60;
extern int     TrailingStop   = 40;

extern bool    wantSpreadBO   = false;
extern int     VarSpread      = 8;

extern int     BBTF           = 1;
extern int     BarsForRange   = 15;

extern bool    wantBBbuys     = true;
extern double  BBBuyLots      = 0.5;
extern int     BuyBarPips     = 12;
extern int     BuyBarTP       = 25;
extern int     BuyBarSL       = 125;

extern bool    wantBBsells    = true;
extern double  BBSellLots     = 0.5;
extern int     SellBarPips    = 12;
extern int     SellBarTP      = 25;
extern int     SellBarSL      = 125;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| CheckForPendingClose1 conditions                                 |
//+------------------------------------------------------------------+ 
void CheckForPendingClose1()
  {
     int  totalorders = OrdersTotal();
     
     for(int i=totalorders-1;i>=0;i--)                              
      {
        OrderSelect( i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC1)  
         {  
          if ( OrderType() == OP_BUYSTOP ) bool result = OrderDelete( OrderTicket() );
          if ( OrderType() == OP_SELLSTOP )     result = OrderDelete( OrderTicket() );
         }
      } 
   return;
 }

//+------------------------------------------------------------------+
//| CheckForPendingClose2 conditions                                 |
//+------------------------------------------------------------------+ 
void CheckForPendingClose2()
  {
     int  totalorders = OrdersTotal();
     
     for(int i=totalorders-1;i>=0;i--)                              
      {
        OrderSelect( i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC2)  
         {  
          if ( OrderType() == OP_BUYSTOP ) bool result = OrderDelete( OrderTicket() );
          if ( OrderType() == OP_SELLSTOP )     result = OrderDelete( OrderTicket() );
         }
      } 
   return;
 }
 
//+------------------------------------------------------------------+
//| Break even code                                                  |
//+------------------------------------------------------------------+ 
 void DoBE(int byPips)
  {
    for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == MAGIC1) || (OrderMagicNumber() == MAGIC2))  
        {
            if (OrderType() == OP_BUY) if (Bid - OrderOpenPrice() > byPips * Point) if (OrderStopLoss() < OrderOpenPrice()) {
              OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() +  Point, OrderTakeProfit(), Red);
            }
            if (OrderType() == OP_SELL) if (OrderOpenPrice() - Ask > byPips * Point) if (OrderStopLoss() > OrderOpenPrice()) { 
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() -  Point, OrderTakeProfit(), Red);
            }
        }
    }
  }

//+------------------------------------------------------------------+
//| Trailing stop code                                               |
//+------------------------------------------------------------------+ 
  void DoTrail()
  {
    for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == MAGIC1) || (OrderMagicNumber() == MAGIC2))  
        {
          
          if (OrderType() == OP_BUY) {
             if(Bid-OrderOpenPrice()>Point*TrailingStop)
             {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
             }
          }

          if (OrderType() == OP_SELL) 
          {
             if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
             {
                if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                {
                   OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                   return(0);
                }
             }
          }
       }
    }
 }
    
//+------------------------------------------------------------------+
//| Check for NewsBreak1 order conditions                            |
//+------------------------------------------------------------------+
void CheckForNewsBreak1()
  {
   double h=High[Highest(NULL,0,MODE_HIGH,NewsLookBack,0)];
   double l=Low[Lowest(NULL,0,MODE_LOW,NewsLookBack,0)];
   double sp=Ask-Bid;
   double ho=h+sp+NewsPips*Point;
   double lo=l-sp-NewsPips*Point;
   double hsl=ho-NewsSL*Point;
   double lsl=lo+NewsSL*Point;
   double htp=ho+NewsTP*Point;
   double ltp=lo-NewsTP*Point;

 //---- breakout conditions
     
      OrderSend(Symbol(),OP_BUYSTOP,NewsLots,ho,3,hsl,htp,"",MAGIC1,0,Green);
      OrderSend(Symbol(),OP_SELLSTOP,NewsLots,lo,3,lsl,ltp,"",MAGIC1,0,Red);
     
 } 
     
//+------------------------------------------------------------------+
//| Check for NewsBreak2 order conditions                            |
//+------------------------------------------------------------------+
void CheckForNewsBreak2()
  {
   double h=High[Highest(NULL,0,MODE_HIGH,NewsLookBack,0)];
   double l=Low[Lowest(NULL,0,MODE_LOW,NewsLookBack,0)];
   double sp=Ask-Bid;
   double ho=h+sp+NewsPips*Point;
   double lo=l-sp-NewsPips*Point;
   double hsl=ho-NewsSL*Point;
   double lsl=lo+NewsSL*Point;
   double htp=ho+NewsTP*Point;
   double ltp=lo-NewsTP*Point;
   double  NewsTime1 = (NewsHour1*3600)+(NewsMinutes1*60);
   double  NewsTime2 = (NewsHour2*3600)+(NewsMinutes2*60);
   double  openbar1  = iBarShift(NULL, 0, NewsTime1);
   double  openbar2  = iBarShift(NULL, 0, NewsTime2);
  
      if(sp > VarSpread && Bid>=openbar1+NewsPips*Point || sp > 8 && Ask<=openbar1-NewsPips*Point)
       {
        OrderSend(Symbol(),OP_BUYSTOP,NewsLots,ho,3,hsl,htp,"",MAGIC2,0,PaleGreen);
        OrderSend(Symbol(),OP_SELLSTOP,NewsLots,lo,3,lsl,ltp,"",MAGIC2,0,Pink);
       }
      if(sp > VarSpread && Bid>=openbar2+NewsPips*Point || sp > 8 && Ask<=openbar2-NewsPips*Point)
       {
        OrderSend(Symbol(),OP_BUYSTOP,NewsLots,ho,3,hsl,htp,"",MAGIC2,0,PaleGreen);
        OrderSend(Symbol(),OP_SELLSTOP,NewsLots,lo,3,lsl,ltp,"",MAGIC2,0,Pink);
       }
       
  }

//+------------------------------------------------------------------+
//| Check for NewsBreak3 order conditions                            |
//+------------------------------------------------------------------+
void CheckForNewsBreak3()
  {
   double hprice=High[Highest(NULL,PERIOD_M1,MODE_HIGH,4,0)];
   double lprice=Low[Lowest(NULL,PERIOD_M1,MODE_LOW,4,0)];
   double h=iHigh(NULL,PERIOD_M1,0);
   double l=iLow(NULL,PERIOD_M1,0);
   double sp=Ask-Bid;
   double ho=h+sp+NewsPips*Point;
   double lo=l-sp-NewsPips*Point;
   double hsl=ho-NewsSL*Point;
   double lsl=lo+NewsSL*Point;
   double htp=ho+NewsTP*Point;
   double ltp=lo-NewsTP*Point;
     
      if(sp > 8 && Bid>=lprice+(NewsPips*Point))
       {
        OrderSend(Symbol(),OP_BUY,NewsLots-(10*Point),Ask,3,hsl,htp,"",MAGIC3,0,Blue);
       }
       
      if(sp > 8 && Ask<=hprice-(NewsPips*Point))
       {
       OrderSend(Symbol(),OP_SELL,NewsLots-(10*Point),Bid,3,lsl,ltp,"",MAGIC3,0,Orange);
       }
 }
//+------------------------------------------------------------------+
//| Check for BB Buy conditions                                      |
//+------------------------------------------------------------------+
void CheckForBBbuys()
  {
   double hprice=High[Highest(NULL,BBTF,MODE_HIGH,BBTF,BarsForRange)];
   double lprice=Low[Lowest(NULL,BBTF,MODE_LOW,BBTF,BarsForRange)];
   
    if(Bid-iOpen(NULL,BBTF,0) >= BuyBarPips*Point) OrderSend(Symbol(),OP_BUY,BBBuyLots,Ask,3,Ask-BuyBarSL*Point,Ask+BuyBarTP*Point,"",MAGIC4,0,LimeGreen);
   }

//+------------------------------------------------------------------+
//| Check for BB Sell conditions                                     |
//+------------------------------------------------------------------+
void CheckForBBsells()
  {
   double hprice=High[Highest(NULL,BBTF,MODE_HIGH,BBTF,BarsForRange)];
   double lprice=Low[Lowest(NULL,BBTF,MODE_LOW,BBTF,BarsForRange)];
   
    if(iOpen(NULL,BBTF,0)-Ask >= SellBarPips*Point) OrderSend(Symbol(),OP_SELL,BBSellLots,Bid,3,Bid+SellBarSL*Point,Bid-SellBarTP*Point,"",MAGIC4,0,Magenta);
   } 
        
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+

void start()
  {
//---- check for history and trading
      
   double  i, OpenBuyLots1, BuyOrders1, OpenSellLots1, SellOrders1, OpenOrders1;
   double  CurrencyProfit1, BuyProfit1, SellProfit1, OpenLots1, TotalLotsOpen;
   double  OpenBuyLots2, BuyOrders2, OpenSellLots2, SellOrders2, OpenOrders2;
   double  CurrencyProfit2, BuyProfit2, SellProfit2, OpenLots2, CurrencyProfit;
   double  BuyProfit3, SellProfit3, BuyOrders3, SellOrders3, OpenOrders3;
   double  NewsTime1 = (NewsHour1*3600)+(NewsMinutes1*60)-90;
   double  NewsTime2 = (NewsHour2*3600)+(NewsMinutes2*60)-90;
   double  PendingBuyStop1, PendingSellStop1, PendingBuyStop2, PendingSellStop2;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
   bool    needpending1 = true;
   bool    needpending2 = true;
   bool    needbuy3     = true;
   bool    needsell3    = true;
   bool    needbuy4     = true;
   bool    needsell4    = true;
   datetime    BBbartime   = iTime(NULL, BBTF, BarsForRange);
   int barminutes = Period();
            
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC1)
        {
         if (OrderType() == OP_BUY) datetime  buytradetime1 = OrderOpenTime();
         if (OrderType() == OP_SELL) datetime  selltradetime1 = OrderOpenTime();
         if (OrderType() == OP_BUYSTOP) PendingBuyStop1 ++;
         if (OrderType() == OP_SELLSTOP) PendingSellStop1 ++;
        }
       if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC2)
        {
         if (OrderType() == OP_BUY) datetime  buytradetime2 = OrderOpenTime();
         if (OrderType() == OP_SELL) datetime  selltradetime2 = OrderOpenTime();
         if (OrderType() == OP_BUYSTOP) PendingBuyStop2 ++;
         if (OrderType() == OP_SELLSTOP) PendingSellStop2 ++;
        }
       if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC3)
        {
         if (OrderType() == OP_BUY) datetime  buytradetime3 = OrderOpenTime();
         if (OrderType() == OP_SELL) datetime  selltradetime3 = OrderOpenTime();
        }
       if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC4)
        {
         if (OrderType() == OP_BUY) datetime  buytradetime4 = OrderOpenTime();
         if (OrderType() == OP_SELL) datetime  selltradetime4 = OrderOpenTime();
        }
      }
         
   if (buytradetime1 >= NewsTime1+90 && buytradetime1 < NewsTime1+ PendingTime) needpending1 = false;
   if (selltradetime1 >= NewsTime1+90 && buytradetime1 < NewsTime1+ PendingTime) needpending1 = false;
   if (buytradetime2 >= NewsTime2+90 && buytradetime2 < NewsTime2+ PendingTime) needpending2 = false;
   if (selltradetime2 >= NewsTime2+90 && buytradetime2 < NewsTime2+ PendingTime) needpending2 = false;

   if(CurrentTime >= NewsTime1 + PendingTime && CurrentTime < NewsTime2 - 120) CheckForPendingClose1();
   if(CurrentTime < NewsTime1 - 120 || CurrentTime >= NewsTime2 + PendingTime) CheckForPendingClose1();
   if(wantOCO && PendingBuyStop1 + PendingSellStop1 != 2)  CheckForPendingClose1();
   if(PendingBuyStop2 + PendingSellStop2 != 2)  CheckForPendingClose2();
     
   if(BEpips>0) DoBE(BEpips);
   if(TrailingStop>0) DoTrail();
   
   if(buytradetime3 > Time[0]+ barminutes*60) needbuy3 = false;
   if(selltradetime3 > Time[0]+ barminutes*60) needsell3 = false;
   if(buytradetime4 > Time[0]+ barminutes*60) needbuy4 = false;
   if(selltradetime4 > Time[0]+ barminutes*60) needsell4 = false;

Comment(" TotalLotsOpen ", TotalLotsOpen,NL,
         " CurrencyProfit ", CurrencyProfit,NL,
         " NewsTime1 ", (NewsHour1*3600)+(NewsMinutes1*60),NL,
         " NewsTime2 ", (NewsHour2*3600)+(NewsMinutes2*60), NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));

   if((AccountMargin()/AccountBalance())>RiskPercent/100) return;
   
   if(wantNews1 && CurrentTime >= NewsTime1 && CurrentTime <= NewsTime1 + 90 
   && PendingBuyStop1 == 0 && PendingSellStop1 == 0) CheckForNewsBreak1();
   if(needpending2 && wantNews2 && CurrentTime >= NewsTime2 && CurrentTime <= NewsTime2 + 90 
   && PendingBuyStop1 == 0 && PendingSellStop1 == 0) CheckForNewsBreak1();
   if(PendingBuyStop2 + PendingSellStop2 == 0) CheckForNewsBreak2();
   
   if(needbuy3) CheckForNewsBreak3();
   if(needsell3) CheckForNewsBreak3();

   if(wantBBbuys && needbuy4) CheckForBBbuys();
   if(wantBBsells && needsell4) CheckForBBsells();
                                       
   return;      
  }
//+------------------------------------------------------------------+