//+------------------------------------------------------------------+
//|                                                  NewsBreakv1.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                  August 16, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060816
#include <stdlib.mqh>
#define     NL    "\n"

extern int     NewsHour      = 12;
extern int     NewsMinutes   = 30;
extern double  NewsLots      = 5;
extern int     NewsPips      = 20;
extern int     NewsTP        = 90;
extern int     NewsSL        = 60;     

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| CheckForPendingClose conditions                                  |
//+------------------------------------------------------------------+ 
void CheckForPendingClose()
  {
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60 +Seconds());
   double  NewsTime = (NewsHour*3600)+(NewsMinutes*60);
   double  i;
   
  if  (CurrentTime >= NewsTime + 120)
      {
      for(i = OrdersTotal(); i > 0; i--) 
      {
         OrderSelect(i, SELECT_BY_POS);
         if(OrderSymbol()==Symbol()) 
         {
         bool result = false;
         
            if(OrderType()==OP_BUYSTOP)  result = OrderDelete( OrderTicket() );
            if(OrderType()==OP_SELLSTOP) result = OrderDelete( OrderTicket() );
            }
         }//End for loop
      }//End Closing All Open and Pending Orders
    }
    
//+------------------------------------------------------------------+
//| Check for NewsBreak order conditions                             |
//+------------------------------------------------------------------+
void CheckForNewsBreak()
  {
   int    vol = 1;
   double CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60+Seconds());
   double NewsTime = (NewsHour*3600)+(NewsMinutes*60)-60;
   double h=iHigh(Symbol(),PERIOD_M1,0);
   double l=iLow(Symbol(),PERIOD_M1,0);
   double sp=Ask-Bid;
   double ho=h+sp+NewsPips*Point;
   double lo=l-sp-NewsPips*Point;
   double hsl=ho-NewsSL*Point;
   double lsl=lo+NewsSL*Point;
   double htp=ho+NewsTP*Point;
   double ltp=lo-NewsTP*Point;
   
 //---- breakout conditions   
    
    if(CurrentTime >= NewsTime && CurrentTime < NewsTime + 120)
     {
      if(Volume[0]> vol) return;
      OrderSend(Symbol(),OP_BUYSTOP,NewsLots,ho,3,hsl,htp,"",MAGICMA,0,Green);
      OrderSend(Symbol(),OP_SELLSTOP,NewsLots,lo,3,lsl,ltp,"",MAGICMA,0,Red);
     }
//----
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
      
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, OpenOrders;
   double  CurrencyProfit, BuyProfit, SellProfit, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
          }
        }
     }
   OpenOrders = BuyOrders + SellOrders;
   OpenLots = OpenBuyLots + OpenSellLots;
   CurrencyProfit = BuyProfit + SellProfit;
 
   CheckForPendingClose();
     
   CheckForNewsBreak();
                                       
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " CurrencyProfit ", CurrencyProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
   return;      
  }
//+------------------------------------------------------------------+