//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|             OpenBuy
//|   Last Updated 1-16-2007 3:00am
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double Lots                = 1;
extern int    Orders              = 1;       // number of orders at Lots
extern int    OrderTime           = 15;
extern int    SL                  = 60;
extern int    TP                  = 30;
extern int    WedIncrease         = 3;
extern bool   CloseAllNOW         = false;
extern bool   LotIncrease         = false;  
extern bool   IsAcctMini          = false;

int    Slippage                = 3;             // how many pips of slippage can you tolorate
bool   OneOrderOnly            = false ;        // one order at a time or not

int    MagicNumber             = 51449692321;       // allows multiple experts to trade on same account
string TradeComment            = "OpenBuy.txt"; // comment so multiple EAs can be seen in Account History
double StartingBalance  = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed            = true;          // used to manage trades
datetime    bartime            = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if (OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for BUY order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double   BuyOrders, LowestBuy=1000;
   int      cnt=0;
   int      gle=0;
   
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
        {
          BuyOrders++;
        }
     }
     
    if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>100) Lots=100;
     }
   if(DayOfWeek()==3) Lots = Lots*WedIncrease;
   
   if(TradeAllowed)
     {
        for(int i=1;i<Orders+1;i++)
         {
        OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-SL*Point,Ask+TP*Point,TradeComment,MagicNumber,Blue);
         }
         gle=GetLastError();
         if(gle==0)
           {
            TradeAllowed=false;
           }
       }
   }
 
//+--------------------------------------------------+
//|  Main Start Routine                              
//+--------------------------------------------------+
int start()
  {
   
   double   OrdersBUY, BuyLots;
   double   CurrentHour = TimeHour(CurTime());
   double   CurrentMinute = TimeMinute(CurTime());
   bool     BUYme=false;

   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
        }
     }
    
 if(CloseAllNOW) CloseAllThisSymbolBuy();
 
// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if(CurrentHour == OrderTime && CurrentMinute <=4) 
       {
        BUYme=true;
       }
    if (BUYme == true) CheckForBuy();

   Comment("                    OpenBuy Last Update 1-16-2006 3:00pm", NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyLots        ", BuyLots, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL,
           "                            Margin              ", AccountMargin(), NL,
           "                            MarginPercent        ", MathRound((AccountEquity()/AccountMargin())*100), NL,
           "                            Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));   
    
 } // end start()

