//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|               SStoch1 
//|   Last Updated 11-14-2006 10:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL    "\n" 
#include <stdlib.mqh>

extern double Lots           =  0.2;    // how many lots to trade at a time
extern double Weight         =  0.05;
extern int    timeframe      =  60;     // time frame for longer term trend that allows for trading to occur 
extern int    startbuy       =  5;     // allows trading when longstoch gets below this level
extern int    startsell      =  95;     // allows trading when longstoch gets above this level
extern int    StochK         =  60;     // stochastic setting on "longterm" time frame
extern int    StochD         =  4;     // stochastic setting on "longterm" time frame
extern int    StochSlowing   =  10;     // stochastic setting on "longterm" time frame
extern int    ProfitPips     =  25;
extern double MaxLots        =  3;
extern int    TargetLevel    =  12;       // 1 = Low Risk 2 = Medium Risk, 3 = High Risk
extern int    TradeLevel     =  16;
extern int    Spacing        =  9;       // min distance above last high or below last low
extern int    MaxMargin      =  5000;
extern bool   PlayAlert      =  true;
extern bool   LotIncrease    =  true;  
extern bool   Boost          =  true;    // buy more as the distance outside the band increases
extern bool   IsAcctMini     =  false;
extern bool   EndTrading     =  false;   // closes EA after all trades close
extern int    EndHour        =  23;      // stop trading after this time friday

int    EndDay       =    365;
int    Slippage     =    0;        // how many pips of slippage can you tolorate
bool   OneOrderOnly =    false ;   // one order at a time or not
double BoostTrack;                 // used to track compounding and steps

int    MagicNumber  =   778624;        // allows multiple experts to trade on same account
string TradeComment = "_SStoch.txt";   // comment so multiple EAs can be seen in Account History
double StartingBalance = 0;                 // lot size control if LotIncrease == true
bool   TradeAllowed=true;                // used to manage trades

// Min/Max tracking and tick logging
int    maxOrders;                        // statistic for maximum numbers or orders open at one time
double maxEquity;                        // statistic for maximum equity level
double minEquity;                        // statistic for minimum equity level
double maxOEquity;                       // statistic for maximum equity level per order
double minOEquity;                       // statistic for minimum equity level per order 
double EquityPos=0;                      // statistic for number of ticks order was positive
double EquityNeg=0;                      // statistic for number of ticks order was negative
double EquityZer=0;                      // statistic for number of ticks order was zero

//+-------------+
//| Custom init |
//|-------------+

int init()
  {
   if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+

int deinit()
  {

  }
  
//+---------------------------------------------------+
//| Closes all Buys this symbol only                  |
//+---------------------------------------------------+
void CloseAllThisSymbolBuy()
{
 
   for(int i = 0; i < OrdersTotal(); i++)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  
         {
           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
     
  return; 
}
   
//+-----------------------------------------------------+
//| Closes all Sells this symbol only                   |
//+-----------------------------------------------------+
void CloseAllThisSymbolSell()
{

   for(int i = 0; i < OrdersTotal(); i++)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
       {
         if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
 
  return; 
}

//+----------------------------------------------+
//| cancels all Buys in Profit                   |
//+----------------------------------------------+
void CloseSymbolBuysinProfit()
{
  int OrdersBUY, BuyProfit;
 
   for(int i = 0; i < OrdersTotal(); i++)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  
         {
           if ( OrderType() == OP_BUY ) BuyProfit = OrderProfit() + OrderSwap() + OrderCommission();
             {
              if ( OrderType() == OP_BUY && BuyProfit > 0 && OrderProfit()>0)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
             }
         }
       }
     
  return; 
}
   
//+-----------------------------------------------+
//| cancels all Sells in Profit                   |
//+-----------------------------------------------+
void CloseSymbolSellsinProfit()
{
  int OrdersSELL, SellProfit;
 
   for(int i = 0; i < OrdersTotal(); i++)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)  
       {
        if ( OrderType() == OP_SELL ) SellProfit = OrderProfit() + OrderSwap() + OrderCommission();
          {
          if ( OrderType() == OP_SELL  && SellProfit > 0 && OrderProfit()>0)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
          }
       }
     }
 
  return; 
}
    
//+------------------------------------------------------------------+
//| Check for BUY order conditions                                   |
//+------------------------------------------------------------------+
void CheckForBuy ()
  {
   double   i, BuyPips, BuyLots, HighestBuyLots;
   double   LowestBuy = 1000;
   int      OrdersBUY;
   int      OrdersPerSymbol;
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   double   SL=0;
   double   TP=0;
      
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
         OrdersBUY++;
         if(OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
         if(OrderLots()>HighestBuyLots) HighestBuyLots=OrderLots();
        }
     } 
   if (Ask > LowestBuy - Spacing*Point) TradeAllowed = false;

   if(LotIncrease)
     {
      BuyLots=NormalizeDouble(AccountBalance()/StartingBalance,2);
     } 
   
   if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
    //ENTRY LONG (buy, Ask)
   if( TradeAllowed )
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_BUY,NormalizeDouble(BuyLots + (OrdersBUY * Weight),2),Ask,Slippage,SL,TP,TradeComment,MagicNumber,Blue);
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
            break;
           }
        }//while
     }//BUYme
   }
    
//+------------------------------------------------------------------+
//| Check for SELL order conditions                                   |
//+------------------------------------------------------------------+
void CheckForSell ()
  {
   double   i, SellPips, SellLots, HighestSell, HighestSellLots;
   int      OrdersSELL;
   int      OrdersPerSymbol;
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   double   SL=0;
   double   TP=0;
      
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
         OrdersSELL++;
         if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
         if(OrderLots()>HighestSellLots) HighestSellLots=OrderLots();
        }
     } 
   if (Bid < HighestSell + Spacing*Point) TradeAllowed = false;

   if(LotIncrease)
     {
      SellLots=NormalizeDouble(AccountBalance()/StartingBalance,2);
     } 
   
   if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   //ENTRY SHORT (sell, Bid)
   if( TradeAllowed )
     {
      while(true)
        {
         ticket=OrderSend(Symbol(),OP_SELL,NormalizeDouble(SellLots + (OrdersSELL * Weight),2),Bid,Slippage,SL,TP,TradeComment,MagicNumber,Red);
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
            break;
           }
        }//while
     }//SELLme
   }
    
//+-----------+
//| Main      |
//+-----------+
int start()
  {
  
    // Is the EA still valid?
   if (DayOfYear() >= EndDay) 
      {
         Alert("EA has expired...");
         return;
      }
 
   int      cnt=0;
   int      gle=0;
   int      ticket=0;
   int      OrdersPerSymbol=0;
   int      OrdersBUY=0;
   int      OrdersSELL=0;
  
   // stoploss and takeprofit and close control
   double LowestBuy = 1000;
   double HighestSell, BuyLots, SellLots, BuyProfit, SellProfit;
   double BuyTarget, SellTarget;
   double CurrentHour = (TimeHour(CurTime()));
   double CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);       

   // direction control
   bool BUYme=false;
   bool SELLme=false;
   OrdersPerSymbol=0;
 
//+------------------------------------------------------------------+
//  Determine last order price                                       |
//-------------------------------------------------------------------+
      for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
           {
           if(OrderType()==OP_BUY && OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
           if(OrderType()==OP_SELL && OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
           OrdersPerSymbol++;
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit() + OrderSwap() + OrderCommission();
           if (OrderType() == OP_SELL) SellProfit +=  OrderProfit() + OrderSwap() + OrderCommission();
           }
      }
      
     BuyTarget  = Lots * TargetLevel;   
     SellTarget = Lots * TargetLevel;
     if(!IsAcctMini)
      {
      BuyTarget = BuyTarget * 10;
      SellTarget = SellTarget * 10;
      }
                      
    if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
    if(SellProfit > SellTarget) CloseAllThisSymbolSell();

    if(Bid > LowestBuy + ProfitPips*Point) CloseSymbolBuysinProfit(); 
    if(Ask < HighestSell - ProfitPips*Point) CloseSymbolSellsinProfit();
    
    if(OrdersPerSymbol==0)
     {
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   Comment("                    Sells ", OrdersSELL,NL,
           "                    Sell Lots ", SellLots, NL,
           "                    HighestSell ", HighestSell,NL,
           "                    Buys ", OrdersBUY,NL,
           "                    BuyLots ", BuyLots, NL,
           "                    LowestBuy ", LowestBuy, NL,
           "    Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
 
 //---- long Stochastic indicator
  double currentstoch  = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
  double previousstoch = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);

    if(previousstoch>currentstoch && currentstoch > startsell)  
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     }
         
   if(previousstoch<currentstoch && currentstoch < startbuy)  
      {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
        
   if (EndTrading == true && OrdersSELL == 0) SELLme = false;
   if (DayOfWeek()>=5 && CurrentHour >= EndHour && OrdersSELL == 0) SELLme =false; 

   if (EndTrading == true && OrdersBUY == 0) BUYme = false;
   if (DayOfWeek()>=5 && CurrentHour >= EndHour && OrdersBUY == 0) BUYme =false; 
  
   if (BUYme == true && Ask < LowestBuy - Spacing*Point)  CheckForBuy();

   if (SELLme == true && Bid > HighestSell + Spacing*Point) CheckForSell();
     
 } // start()

 




