//+------------------------------------------------------------------+
//|                                                  SimpleStoch.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                   August 9, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060804
#include <stdlib.mqh>
#define     NL    "\n"

extern double lots              = 0.2;     // divides max lots by this number, lower = bigger lots
extern int  TradingMode         = 1;      // Mode 1=Stoch close, No short trades; 
                                          //      2=TP, No short trades;
                                          //      3=Stoch close plus short trades;
                                          //      4=TP plus short trades;
                                          //      5=short trades only; 
extern int vol                  = 5;      // sets trades for this many ticks of current bar
extern int CloseAllAbove        = 0.1;    // closes all trades above this amount if close conditions are met
extern int longterm             = 15;     // time frame for longer term trend that allows for trading to occur 
extern int CloseBuyLevel        = 90;     // level where buys close when StochSignal begins to drop
extern int CloseSellLevel       = 10;     // level where sells close when tochSignal begins to rise
extern int startbuy             = 15;     // allows trading when longstoch gets below this level
extern int startsell            = 85;     // allows trading when longstoch gets above this level

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int LongStochK         = 40;     // stochastic setting on "longterm" time frame
   int LongStochD         = 10;     // stochastic setting on "longterm" time frame
   int LongStochSlowing   = 12;     // stochastic setting on "longterm" time frame
   int UpperStochLevel    = 75;     // level for sells to take place
   int LowerStochLevel    = 25;     // level for buys to take place
   double  previouslongstoch, currentlongstoch;
  
     
 //---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
   
 //---- long Stochastic indicator
   currentlongstoch  = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   previouslongstoch = iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);
 //---- lot setting and modifications
    
  
   
//---- buy conditions
   if(currentlongstoch < startbuy/* && previouslongstoch < currentlongstoch*/)  
     {
      OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"",MAGICMA,0,Blue);
      return;
      }
    
  
//---- sell conditions 
   
    if(currentlongstoch > startsell && previouslongstoch > currentlongstoch)  
     {
      OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"",MAGICMA,0,Orange);
      return;
      }
     
     
//----
  }
//+------------------------------------------------------------------------+
//| cancells all pending orders   and closes open positions               |
//+------------------------------------------------------------------------+

void CloseAll()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
           
      }
  }
  return; 
  } 
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   int LongStochK         = 40;     // stochastic setting on "longterm" time frame
   int LongStochD         = 10;     // stochastic setting on "longterm" time frame
   int LongStochSlowing   = 12;     // stochastic setting on "longterm" time frame
   int UpperStochLevel    = 85;     // level for sells to take place
   int LowerStochLevel    = 15;     // level for buys to take place
   double previouslongstoch, currentlongstoch;
   int    i, j, k, ticket, totalorders;
   string Name = "DropKickv18";
      
//---- Stochastic indicator
   currentlongstoch  =iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   previouslongstoch =iStochastic(NULL,longterm,LongStochK,LongStochD,LongStochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);
//---- close buy conditions 
    if(currentlongstoch > CloseBuyLevel)  
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
          if (OrderProfit() > CloseAllAbove) OrderClose(OrderTicket(),OrderLots(),Bid,0,Yellow);
         }
       }
      return;
     }
    if(currentlongstoch < CloseSellLevel)
     {
     totalorders = OrdersTotal();
     for(i=totalorders-1;i>=0;i--)                    // scan all orders and positions...
       {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == MAGICMA) || (OrderComment() == Name)) )  
         { 
          if (OrderType() == OP_SELL)
          { 
          if (OrderProfit() > CloseAllAbove) OrderClose(OrderTicket(),OrderLots(),Ask,0,Yellow);
          }
         }
       }
      return;
     }
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   TotalProfit = BuyProfit + SellProfit;
    
   CheckForClose();
   
   if(AccountEquity() <= AccountBalance()/2) return;
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+