//+------------------------------------------------------------------+
//|                                                SimpleStoch2a.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                   August 9, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060809
#include <stdlib.mqh>
#define     NL    "\n"

extern double ratio             = 20;   // Equity/Balance ratio or profit level to take profit
extern double lots              = 0.3;    // divides max lots by this number, lower = bigger lots
extern int vol                  = 3;      // sets trades for this many ticks of current bar
extern int timeframe            = 15;     // time frame for longer term trend that allows for trading to occur 
extern int startbuy             = 15;     // allows trading when longstoch gets below this level
extern int startsell            = 85;     // allows trading when longstoch gets above this level
extern int StochK               = 60;     // stochastic setting on "longterm" time frame
extern int StochD               = 4;     // stochastic setting on "longterm" time frame
extern int StochSlowing         = 10;     // stochastic setting on "longterm" time frame
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   
   double  previousstoch, currentstoch;
  
     
 //---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
   
 //---- long Stochastic indicator
   currentstoch  = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   previousstoch = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);
 //---- lot setting and modifications
    
  
   
//---- buy conditions
   if(currentstoch < startbuy)  
     {
      OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"",MAGICMA,0,Blue);
      return;
      }
    
  
//---- sell conditions 
   
    if(currentstoch > startsell)  
     {
      OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"",MAGICMA,0,Orange);
      return;
      }
     
     
//----
  }
//+------------------------------------------------------------------------+
//| cancells all pending orders   and closes open positions               |
//+------------------------------------------------------------------------+

void CloseAll()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
           
      }
  }
  return; 
  } 
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  
  //---- close buy conditions 
    if(AccountEquity()/AccountBalance() >= ratio) CloseAll(); 
    
    return;
     
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   TotalProfit = BuyProfit + SellProfit;
    
   if(TotalProfit >= ratio) CloseAll();
   //CheckForClose();
   
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+