//+------------------------------------------------------------------+
//|                                               SimpleStochv3c.mq4 |
//|                                       Copyright  2006, kmrunner |
//|                                                  August 15, 2006 |
//+------------------------------------------------------------------+
#define MAGICMA  20060815
#include <stdlib.mqh>
#define     NL    "\n"

extern double Lots              = 1;    // divides max lots by this number, lower = bigger lots
extern int vol                  = 2;      // sets trades for this many ticks of current bar
extern int timeframe            = 60;     // time frame for longer term trend that allows for trading to occur 
extern int stopbuy              = 15;     // allows trading when longstoch gets below this level
extern int stopsell             = 92;     // allows trading when longstoch gets above this level
extern int StochK               = 35;     // stochastic setting on "longterm" time frame
extern int StochD               = 3;     // stochastic setting on "longterm" time frame
extern int StochSlowing         = 6;     // stochastic setting on "longterm" time frame
extern bool MM                  = true;
extern int RiskPercent          = 5;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
double LotsOptimized()
  {
   double lot=Lots;
  //---- select lot size
   if (MM) lot=NormalizeDouble(MathFloor(AccountFreeMargin()*RiskPercent/100)/100,1);
   
  // lot at this point is number of standard lots
   return(lot);
  }  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double  previousstoch, currentstoch;
       
 //---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
   
 //---- long Stochastic indicator
   currentstoch  = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   previousstoch = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);
 //---- lot setting and modifications
    
  
 //---- buy conditions
   if(previousstoch<currentstoch && currentstoch < stopbuy)  
      {
      OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,0,0,"",MAGICMA,0,Blue);
      return;
      }
    
 //---- sell conditions 
    if(previousstoch>currentstoch && currentstoch > stopsell)  
      {
      OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,0,0,"",MAGICMA,0,Orange);
      return;
      }
 //----
  }
  
//+------------------------------------------------------------------------+
//| cancells all pending orders   and closes open positions               |
//+------------------------------------------------------------------------+
void CloseAll()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
           
      }
  }
  return; 
  } 
    
//+------------------------------------------------------------------+
//| CheckForClose                                                    |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double  previousstoch, currentstoch;
       
 //---- go trading only for first ticks of new bar
   if(Volume[0]>vol) return;
   
 //---- long Stochastic indicator
   currentstoch  = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   previousstoch = iStochastic(NULL,timeframe,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);
 
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
    {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
// modified by cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
    if ( OrderSymbol()==Symbol())  // only look if mygrid and symbol...
     {
      if(currentstoch > stopsell)  
       {
        if ( OrderType() == OP_BUY && OrderProfit()>0)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
       }  
      if(currentstoch < stopsell-5)  
       {
        if ( OrderType() == OP_SELL && OrderProfit()>0)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
     }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
double profitlevel = 100;
void start()
  {
//---- check for history and trading
   if(Bars<100) return;
   
   double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, leveler, MaxLotsAllowed;
   double  TotalProfit, BuyProfit, SellProfit, BuySwap, SellSwap, OpenLots, TotalLotsOpen, Closelevel;
   double  CurrentTime = (TimeHour(CurTime())*3600+TimeMinute(CurTime())*60);
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      TotalLotsOpen += OrderLots();
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY)
          {
           OpenBuyLots += OrderLots();  
           BuyOrders ++;
           BuyProfit +=  OrderProfit();
           BuySwap += OrderSwap();
          }
         if (OrderType() == OP_SELL)
          {
           OpenSellLots += OrderLots();  
           SellOrders ++;
           SellProfit +=  OrderProfit();
           SellSwap += OrderSwap();
          }
        }
     }
   OpenLots = OpenBuyLots + OpenSellLots;
   TotalProfit = BuyProfit + SellProfit;
    
   if(TotalProfit > profitlevel && TotalProfit < Closelevel) CloseAll();
   
   CheckForClose();
   
   if(AccountMargin()>= AccountBalance()/100*RiskPercent) return;
      
   CheckForOpen();
                                      
 Comment(" BuyOrders ", BuyOrders,NL,
         " OpenBuyLots ", OpenBuyLots,NL,
         " BuyProfit ", BuyProfit,NL,
         " SellOrders ", SellOrders,NL,
         " OpenSellLots ", OpenSellLots,NL,
         " SellOrders ", SellOrders,NL,
         " TotalLotsOpen ", TotalLotsOpen,NL,
         " TotalProfit ", TotalProfit,NL,
         " Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));
  }
//+------------------------------------------------------------------+