//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|               StochMA
//|   Last Updated 12-17-2006 3:00am
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double Lots                = 1;
extern int    MaxTrades           = 1;
extern int    Orders              = 1;       // number of orders at Lots
extern int    Profit              = 25;
extern int    MA                  = 200;
extern int    TF                  = 1440;
extern int    LowStoch            = 30;
extern int    HighStoch           = 70;
extern int    K                   = 100;
extern int    D                   = 22;
extern int    SL                  = 30;
extern bool   IsAcctMini          = false;
extern bool   LotIncrease         = true;  
extern bool   UseAlerts           = false;

int    Slippage                = 3;             // how many pips of slippage can you tolorate
bool   OneOrderOnly            = false ;        // one order at a time or not
double BoostTrack              = 0;             // used to track compounding and steps

int    MagicNumber             = 52666687;       // allows multiple experts to trade on same account
string TradeComment            = "StochMA.txt"; // comment so multiple EAs can be seen in Account History
double StartingBalance  = 0;             // lot size control if LotIncrease == true
bool   TradeAllowed            = true;          // used to manage trades
datetime    bartime            = 0;                    

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
    if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if (OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (UseAlerts) PlaySound("yodel.wav");
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| Closes all SELL positions                                              
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
        if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
         if (UseAlerts) PlaySound("yodel.wav");
     }
  }
  return; 
  }
  
//+--------------------------------------------------+
//|  Main Start Routine                              
//+--------------------------------------------------+
int start()
  {
   
   double   OrdersSELL, OrdersBUY;
   double   BuyLots, SellLots, LargestMargin;
   double   CurrentHour = TimeHour(CurTime());
   double   CurrentMinute = TimeMinute(CurTime());
   double   Stoch1 = iStochastic(NULL,TF,K,D,1,MODE_LWMA,0,MODE_SIGNAL,1);
   double   Stoch2 = iStochastic(NULL,TF,K,D,1,MODE_LWMA,0,MODE_SIGNAL,2);
   double   MA1 = iMA(NULL,TF,MA,0,MODE_LWMA,PRICE_MEDIAN,1);
   double   MA2 = iMA(NULL,TF,MA,0,MODE_LWMA,PRICE_MEDIAN,2);
   double   MA3 = iMA(NULL,TF,MA,0,MODE_LWMA,PRICE_MEDIAN,3);
   double   MA4 = iMA(NULL,TF,MA,0,MODE_LWMA,PRICE_MEDIAN,4);

   for(int i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
        }
     }
    
// if(MA1<MA2 && MA3>MA4) CloseAllThisSymbolBuy();
// if(MA1>MA2 && MA3<MA4) CloseAllThisSymbolSell();
 if(OrderProfit()>Profit) CloseAllThisSymbolBuy();
 if(OrderProfit()>Profit) CloseAllThisSymbolSell();
 
    if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50 && IsAcctMini) Lots=50;
      if(Lots>100 && !IsAcctMini) Lots=100;
    }

// Counter Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

//    if(MA1>MA2 && MA3<MA4 && OrdersBUY<MaxTrades) 
    if(Stoch1<LowStoch && OrdersBUY<MaxTrades) 
       {
        OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-SL*Point,0,TradeComment,MagicNumber,Blue);
       }
//    if(MA1<MA2 && MA3>MA4 && OrdersSELL<MaxTrades) 
    if(Stoch1>HighStoch && OrdersSELL<MaxTrades) 
       {
        OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+SL*Point,0,TradeComment,MagicNumber,Orange);
       }

   Comment("                    Falcon Pedro Last Update 12-15-2006 3:00pm", NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyLots        ", BuyLots, NL,
           "                            Sells    ", OrdersSELL, NL,
           "                            SellLots        ", SellLots, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL,
           "                            Margin              ", AccountMargin(), NL,
           "                            MarginPercent        ", MathRound((AccountEquity()/AccountMargin())*100), NL,
           "                            Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));   
    
 } // end start()

