//+------------------------------------------------------------------+
//|                                          Set Buy Sell Orders.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <stdlib.mqh>
#define MAGIC 897897898

extern string s1 = "Lot size";
extern   double Lots = 0.1;
extern string s2 = "Pips above/below current price";
extern   int Trap = 15;
extern string s3 = "Pips between every panding order";
extern   int pipsApart = 2;
extern string s4 = "How many trade to open";
extern int  NumTrades    = 50;
extern double TargetLevel    = 10;
extern bool   IsAcctMini    = false;
extern int     NewsHour1      = 0;
extern int     NewsMinutes1   = 01;

bool UseImmediate = false;


//+-------------+
//| Custom init |
//|-------------+
int init()
  {

  }

//+----------------+
//| Custom DE-init |
//+----------------+

int deinit()
  {
   return(0);
}
//+---------------------------------------------------+
//| Closes all Buys this symbol only                  |
//+---------------------------------------------------+
void CloseAllThisSymbolBuy()
{
 
   for(int i = 0; i < OrdersTotal(); i++)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)  
         {
           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
     
  return; 
}
   
//+-----------------------------------------------------+
//| Closes all Sells this symbol only                   |
//+-----------------------------------------------------+
void CloseAllThisSymbolSell()
{

   for(int i = 0; i < OrdersTotal(); i++)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC) 
       {
         if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
     }
 
  return; 
}

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start(){
   
   double BuyLots, SellLots, BuyProfit, SellProfit, BuyTarget, SellTarget;
   double OrdersBUY, OrdersSELL;
   int    OrdersPerSymbol;
     
   for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
           {
           OrdersPerSymbol++;
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit() + OrderSwap() + OrderCommission();
           if (OrderType() == OP_SELL) SellProfit +=  OrderProfit() + OrderSwap() + OrderCommission();
           }
      }
      
      BuyTarget  = Lots * TargetLevel;   
      SellTarget = Lots * TargetLevel;
   if(!IsAcctMini)
      {
      BuyTarget = BuyTarget * 10;
      SellTarget = SellTarget * 10;
      }
                      
   if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
   if(SellProfit > SellTarget) CloseAllThisSymbolSell();
//----
   
   double buystop = Bid+Trap*Point;
   double sellstop = Ask-Trap*Point;
   double  NewsTime1 = (NewsHour1*3600)+(NewsMinutes1*60)-90;
   int TakeProfit = 2000;
   int StopLoss   = 2000;
   int ii;

   double SL = 0, TP=0;
   
   if (UseImmediate)
   {
      if (StopLoss > 0) SL = Ask-StopLoss*Point;
      if (TakeProfit > 0) TP = Ask+TakeProfit*Point;
      OrderSend(Symbol(),OP_BUY,Lots,Ask,3,SL,TP,"WSS News Trap Buy",16384,0,Green);
      int err = GetLastError();
      Print("Error: ", ErrorDescription(err));
      if (StopLoss > 0) SL = Bid+StopLoss*Point;
      if (TakeProfit > 0) TP = Bid-TakeProfit*Point;
      OrderSend(Symbol(),OP_SELL,Lots,Bid,3,SL, TP,"WSS News Trap Sell",16384,0,Red);   
      err = GetLastError();
      Print("Error: ", ErrorDescription(err));
   }
      
   StopLoss = 2000;
   
   for (ii=0; ii<NumTrades; ii++)
   {
      if (StopLoss > 0) SL = buystop-StopLoss*Point;
      if (TakeProfit > 0) TP = buystop+TakeProfit*Point;
      OrderSend(Symbol(),OP_BUYSTOP,Lots,buystop,3,SL,TP,"WSS News Trap Buy",16384,0,Green);
      err = GetLastError();
      Print("Error: ", ErrorDescription(err));
      buystop += (pipsApart*Point);
   }   
   
   for (ii=0; ii<NumTrades; ii++)
   {
      if (StopLoss > 0) SL = sellstop+StopLoss*Point;
      if (TakeProfit > 0) TP = sellstop-TakeProfit*Point;
      OrderSend(Symbol(),OP_SELLSTOP,Lots,sellstop,3,SL,TP,"WSS News Trap Sell",16384,0,Red);
      err = GetLastError();
      Print("Error: ", ErrorDescription(err));
      sellstop -= (pipsApart * Point);
   }   
//----
   return(0);
  }
//+------------------------------------------------------------------+