//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|               Straddle V1
//|   Last Updated 11-26-2006 6:00pm
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Skyview Investment Group"
#property link      "http://www.Skyview-IG.com"
#define     NL      "\n" 
#include <stdlib.mqh>
#include <WinUser32.mqh>

extern double  LotSize                 = 0.01;
extern double  LotIncrement            = 0.01;
extern int     OrdersPerSide           = 50;    // NumberOfOrdersPerSide X TakeProfitIncrement = Highest TakeProfit Level
extern int     SpacingIncrement        = 3;
extern bool    Trade1                  = true;
extern int     Time1                   = 0;
extern int     PipsForEntry            = 5;
extern int     TargetLevel             = 5;      // number of pips per lot for profit

int    MagicNumber     = 3252668;       // allows multiple experts to trade on same account

//+-------------+
//| Custom init |
//|-------------+
int init()
  {

  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {

  }

//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+
void CloseAllThisSymbol()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol())  // only look if mygrid and symbol...
      {
        //Close opened short positions
        if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
        if ( OrderType()== OP_BUYSTOP)  result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_SELLSTOP)  result = OrderDelete( OrderTicket() );
      }
  }
  return; 
  }
  
//+------------------------------------------------------------------+
//| Start Routine\                                                   |
//+------------------------------------------------------------------+

int start() {

   double   i, OrdersSELL, OrdersBUY, OrdersSELLSTOP, OrdersBUYSTOP, BuyPips, SellPips;
   double   BuyLots, SellLots, BuyProfit, SellProfit, TotalProfit;
  
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol()/* && OrderMagicNumber() == MagicNumber*/)
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUYSTOP)  OrdersBUYSTOP++;
           if(OrderType()==OP_SELLSTOP) OrdersSELLSTOP++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
           if (OrderType() == OP_SELL) SellProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }
   
   TotalProfit = BuyProfit + SellProfit;

   if(TotalProfit > TargetLevel)  CloseAllThisSymbol(); 
      
   double   TradeTime1=Time1;
   double   PFE=PipsForEntry;
   double   CurrentHour=TimeHour(CurTime());
   double   CurrentMinute=TimeMinute(CurTime());
   
   
   if((CurrentHour==TradeTime1 && Trade1)) {
      double highprice=iHigh(NULL,0,1);
      double lowprice=iLow(NULL,0,1);
   }
   double   Spread=Ask-Bid;
   double   hprice=Spread+highprice+PFE*Point;
   double   lprice=lowprice-PFE*Point;
   double   PreviousBarHigh=iHigh(NULL,0,1);
   double   PreviousBarLow=iLow(NULL,0,1);
   double   Previous2ndBarHigh=iHigh(NULL,0,2);
   double   Previous2ndBarLow=iLow(NULL,0,2);
   int      j;
   bool     need_long  = false;
   bool     need_short = false;
   
   
   if(OrdersBUYSTOP == 0 && OrdersSELLSTOP == 0)
     {
     need_long = true;
     need_short = true;
     }
     
       if((CurrentHour==TradeTime1 && Trade1)) {
         if(need_long) {
            for(i=1;i<OrdersPerSide+1;i++) {
               int hticket=OrderSend(Symbol(),OP_BUYSTOP,LotSize+LotIncrement*i,hprice+SpacingIncrement*i*Point,3,0,0,"MultiBreakOut_v0.1",MagicNumber,0,Green);
            }
            if(hticket<(i+1)) {
               int herror=GetLastError();
               Print("Error = ",ErrorDescription(herror));
            }
         }//End need_long
         if(need_short) {
            for(j=1;j<OrdersPerSide+1;j++) {
               int lticket=OrderSend(Symbol(),OP_SELLSTOP,LotSize+LotIncrement*j,lprice-SpacingIncrement*j*Point,3,0,0,"MultiBreakOut_v0.1",MagicNumber,0,Red);
            }
            if(lticket<(j+1)) {
               int lerror=GetLastError();
               Print("Error = ",ErrorDescription(lerror));
            }
         }//End need_short
      
   }//End Else
}//End Start

